Public Class DiagnosenDataGrid
    Inherits System.Windows.Forms.UserControl
    Friend WithEvents DL As DiagnosenDataGridListe
    Private DGTS As DiagnosenDataGridTableStyle
    Private WithEvents ColDatum As DataGridDatumColumn
    Private WithEvents ColEintrag As DiagnosenDataGridICDAuswahlColumn
    Private WithEvents ColText As DiagnosenDataGridTextColumn
    Private Initialized As Boolean = False
    Private m_minWidth As Integer = 165

    Private m_Zeilenzahl As Integer = 0
    Public Event Zeilen_geaendert()
    ReadOnly Property Zeilenzahl() As Integer
        Get
            Return m_Zeilenzahl
        End Get
    End Property
    ReadOnly Property Liste() As DiagnosenDataGridListe
        Get
            Return DL
        End Get
    End Property
    Public Sub Diagnosen_Bearbeiten()
        DL.Diagnosen_Bearbeiten()
    End Sub

    Public Function ToTable() As Table
        Dim TabDiagnosen As New Table(DL.Count + 1, 2)
        TabDiagnosen.Cells(0, 0).TextEintraege.Add(New TextEintrag("ICD"))
        TabDiagnosen.Cells(0, 1).TextEintraege.Add(New TextEintrag("Diagnose"))
        For I As Integer = 0 To DL.Count - 1
            Dim itm As DiagnosenDataGridItem = DL.Item(I)
            TabDiagnosen.Cells(I + 1, 0).TextEintraege.Add(New TextEintrag(itm.Diagnose.ICD))
            TabDiagnosen.Cells(I + 1, 1).TextEintraege.Add(New TextEintrag(itm.Text))
        Next
        Return TabDiagnosen
    End Function

#Region " Vom Windows Form Designer generierter Code "

    Public Sub New()
        MyBase.New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen
    End Sub

    'UserControl berschreibt den Lschvorgang zum Bereinigen der Komponentenliste.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Fr Windows Form-Designer erforderlich
    Private components As System.ComponentModel.IContainer

    'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
    'Sie kann mit dem Windows Form-Designer modifiziert werden.
    'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
    Friend WithEvents DataGrid1 As System.Windows.Forms.DataGrid
    Friend WithEvents Panel1 As System.Windows.Forms.Panel
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.DataGrid1 = New System.Windows.Forms.DataGrid
        Me.Panel1 = New System.Windows.Forms.Panel
        CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.Panel1.SuspendLayout()
        Me.SuspendLayout()
        '
        'DataGrid1
        '
        Me.DataGrid1.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.DataGrid1.CaptionVisible = False
        Me.DataGrid1.DataMember = ""
        Me.DataGrid1.Dock = System.Windows.Forms.DockStyle.Fill
        Me.DataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText
        Me.DataGrid1.Location = New System.Drawing.Point(0, 0)
        Me.DataGrid1.Name = "DataGrid1"
        Me.DataGrid1.Size = New System.Drawing.Size(396, 92)
        Me.DataGrid1.TabIndex = 0
        '
        'Panel1
        '
        Me.Panel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.Panel1.Controls.Add(Me.DataGrid1)
        Me.Panel1.Dock = System.Windows.Forms.DockStyle.Fill
        Me.Panel1.Location = New System.Drawing.Point(0, 0)
        Me.Panel1.Name = "Panel1"
        Me.Panel1.Size = New System.Drawing.Size(398, 94)
        Me.Panel1.TabIndex = 1
        '
        'DiagnosenDataGrid
        '
        Me.Controls.Add(Me.Panel1)
        Me.Name = "DiagnosenDataGrid"
        Me.Size = New System.Drawing.Size(398, 94)
        CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.Panel1.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Public Sub Initialisieren(ByVal VorlagenPfad As String)
        DL = New DiagnosenDataGridListe(VorlagenPfad)
        Me.DataGrid1.DataSource = DL
        DGTS = New DiagnosenDataGridTableStyle(DL)
        Me.DataGrid1.TableStyles.Add(DGTS)
        ColDatum = DGTS.ColDatum
        ColEintrag = DGTS.ColEintrag
        ColText = DGTS.ColText
        Standards_Einstellen()
        Initialized = True
    End Sub

    Private Sub DiagnosenDataGrid_SizeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.SizeChanged
        If Me.Width < m_minWidth Then
            Me.Width = m_minWidth
        End If
        If Not Initialized Then Exit Sub
        Standards_Einstellen()
    End Sub
    Private Sub Standards_Einstellen()
        Initialized = False
        ColDatum.Width = 75
        ColEintrag.Width = 50
        ColText.Width = Me.Width - 162
        DGTS.ColEintrag.DropDownWidth = ColText.Width + ColEintrag.Width
        Initialized = True
    End Sub
    Private Sub ColDatum_WidthChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ColDatum.WidthChanged
        If Not Initialized Then Exit Sub
        TextBreite_Einstellen()
    End Sub

    Private Sub ColEintrag_WidthChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ColEintrag.WidthChanged
        If Not Initialized Then Exit Sub
        TextBreite_Einstellen()
    End Sub
    Private Sub TextBreite_Einstellen()
        ColText.Width = Me.Width - ColDatum.Width - ColEintrag.Width - 35 - 2
        DGTS.ColEintrag.DropDownWidth = ColText.Width + ColEintrag.Width
    End Sub

    Private Sub Berechnen()

        If m_Zeilenzahl <> DL.Count Then
            m_Zeilenzahl = DL.Count
            RaiseEvent Zeilen_geaendert()
        End If

    End Sub
    Private Sub DataGrid1_CurrentCellChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles DataGrid1.CurrentCellChanged
        'Berechnen()
    End Sub

    Private Sub DL_ListChanged(ByVal sender As Object, ByVal e As System.ComponentModel.ListChangedEventArgs) Handles DL.ListChanged
        Berechnen()
    End Sub
End Class
