Imports System.Xml
Imports System.ComponentModel
Public Class DiagnosenDataGridListe
    Inherits CollectionBase
    Implements IBindingList
    Private m_AktuellesDatum As DateTime = DateTime.Now
    Private m_Diagnosen As DiagnosenListe
    ReadOnly Property AktuellesDatum() As DateTime
        Get
            Return m_AktuellesDatum
        End Get
    End Property
    ReadOnly Property Diagnosen() As DiagnosenListe
        Get
            Return m_Diagnosen
        End Get
    End Property
    Public Sub New(ByVal VorlagenPfad As String)
        m_Diagnosen = New DiagnosenListe(VorlagenPfad)
    End Sub
    Default Public ReadOnly Property Item(ByVal index As Integer) As DiagnosenDataGridItem
        Get
            Return DirectCast(list(index), DiagnosenDataGridItem)
        End Get
    End Property
    Public Sub Diagnosen_Bearbeiten()
        Dim frm As New frm_DiagnosenBearbeiten(Me)
        frm.ShowDialog()
    End Sub
    Private Sub ChildChanged(ByVal sender As Object, ByVal e As PropertyChangedEventArgs)

        ' find the item's index
        Dim index As Integer
        For Each item As Object In list
            If item.Equals(sender) Then
                Exit For
            End If
            index += 1
        Next
        If e.PropertyName = "Datum" Then
            Dim Itm As DiagnosenDataGridItem = list.Item(index)
            m_AktuellesDatum = Itm.Datum
        End If
        ' indicate item has changed
        RaiseEvent ListChanged(Me, New ListChangedEventArgs(ListChangedType.ItemChanged, index))

    End Sub

#Region " List event handlers "


    ' Makes sure event handlers are disconnected
    ' before items are removed.

    Protected Overrides Sub OnClear()

        For Each item As DiagnosenDataGridItem In list
            RemoveHandler item.PropertyChanged, AddressOf ChildChanged
        Next

    End Sub


    ' Raises event to indicate list has changed.

    Protected Overrides Sub OnClearComplete()
        RaiseEvent ListChanged(Me, New ListChangedEventArgs(ListChangedType.Reset, 0))
    End Sub


    ' Adds event handler for newly added item. Raises event to
    ' indicate list has changed.

    Protected Overrides Sub OnInsertComplete(ByVal index As Integer, ByVal value As Object)
        AddHandler DirectCast(value, DiagnosenDataGridItem).PropertyChanged, AddressOf ChildChanged
        RaiseEvent ListChanged(Me, New ListChangedEventArgs(ListChangedType.ItemAdded, index))
    End Sub


    ' Removes event handler for removed object. Raises event to
    ' indicate list has changed.

    Protected Overrides Sub OnRemoveComplete(ByVal index As Integer, ByVal value As Object)
        RemoveHandler DirectCast(value, DiagnosenDataGridItem).PropertyChanged, AddressOf ChildChanged
        RaiseEvent ListChanged(Me, New ListChangedEventArgs(ListChangedType.ItemDeleted, index))
    End Sub


    ' Removes event handler for removed object, and adds event
    ' handler for newly added item. Raises event to indicate
    ' list has changed.

    Protected Overrides Sub OnSetComplete(ByVal index As Integer, ByVal oldValue As Object, ByVal newValue As Object)
        RemoveHandler DirectCast(oldValue, DiagnosenDataGridItem).PropertyChanged, AddressOf ChildChanged
        AddHandler DirectCast(newValue, DiagnosenDataGridItem).PropertyChanged, AddressOf ChildChanged
        RaiseEvent ListChanged(Me, New ListChangedEventArgs(ListChangedType.ItemChanged, index))
    End Sub

#End Region

#Region " IBindingList "


    ' Not implemented.

    Public Sub AddIndex(ByVal [property] As System.ComponentModel.PropertyDescriptor) Implements System.ComponentModel.IBindingList.AddIndex

    End Sub


    ' Adds a new item to the list.

    ' <remarks>
    ' This is implemented to support the DataGrid so it can
    ' add items to the list dynamically.
    ' </remarks>
    Public Function AddNew() As Object Implements System.ComponentModel.IBindingList.AddNew
        Dim item As New DiagnosenDataGridItem(Me)
        list.Add(item)
        Return item
    End Function


    ' Removes a child from the list.

    ' <remarks>
    ' This is implemented to support the DataGrid so it can
    ' add items to the list dynamically. If an item is added
    ' dynamically and then the user presses Esc the item will
    ' request that it be removed from the list by calling this
    ' method. Look at the CancelEdit method in DiagnosenDataGridItem to
    ' see when this method is called.
    ' </remarks>
    ' <param name="child">The child to remove.</param>
    Friend Sub RemoveChild(ByVal child As DiagnosenDataGridItem)
        Dim index As Integer
        For Each item As DiagnosenDataGridItem In list
            If item.Equals(child) Then
                Exit For
            End If
            index += 1
        Next
        list.RemoveAt(index)
    End Sub


    ' Returns True so we support in-place editing.

    Public ReadOnly Property AllowEdit() As Boolean Implements System.ComponentModel.IBindingList.AllowEdit
        Get
            Return True
        End Get
    End Property


    ' Returns True so we support dynamic adding of child objects.

    Public ReadOnly Property AllowNew() As Boolean Implements System.ComponentModel.IBindingList.AllowNew
        Get
            Return True
        End Get
    End Property


    ' Returns True so we support dynamic removal of child objects.

    Public ReadOnly Property AllowRemove() As Boolean Implements System.ComponentModel.IBindingList.AllowRemove
        Get
            Return True
        End Get
    End Property


    ' Not implemented.

    Public Sub ApplySort(ByVal [property] As System.ComponentModel.PropertyDescriptor, ByVal direction As System.ComponentModel.ListSortDirection) Implements System.ComponentModel.IBindingList.ApplySort

    End Sub


    ' Not implemented.

    Public Function Find(ByVal [property] As System.ComponentModel.PropertyDescriptor, ByVal key As Object) As Integer Implements System.ComponentModel.IBindingList.Find

    End Function


    ' Return False. This collection is not sortable.

    Public ReadOnly Property IsSorted() As Boolean Implements System.ComponentModel.IBindingList.IsSorted
        Get
            Return False
        End Get
    End Property


    ' Raised to indicate that data in the list has changed.

    Public Event ListChanged(ByVal sender As Object, ByVal e As System.ComponentModel.ListChangedEventArgs) Implements System.ComponentModel.IBindingList.ListChanged


    ' Not implemented.

    Public Sub RemoveIndex(ByVal [property] As System.ComponentModel.PropertyDescriptor) Implements System.ComponentModel.IBindingList.RemoveIndex

    End Sub


    ' Not implemented.

    Public Sub RemoveSort() Implements System.ComponentModel.IBindingList.RemoveSort

    End Sub


    ' Not implemented.

    Public ReadOnly Property SortDirection() As System.ComponentModel.ListSortDirection Implements System.ComponentModel.IBindingList.SortDirection
        Get
            Return ListSortDirection.Ascending
        End Get
    End Property


    ' Not implemented.

    Public ReadOnly Property SortProperty() As System.ComponentModel.PropertyDescriptor Implements System.ComponentModel.IBindingList.SortProperty
        Get
            Return Nothing
        End Get
    End Property


    ' Returns True. This object will raise the ListChanged event.

    Public ReadOnly Property SupportsChangeNotification() As Boolean Implements System.ComponentModel.IBindingList.SupportsChangeNotification
        Get
            Return True
        End Get
    End Property


    ' Returns False. This object does not implement searching.

    Public ReadOnly Property SupportsSearching() As Boolean Implements System.ComponentModel.IBindingList.SupportsSearching
        Get
            Return False
        End Get
    End Property


    ' Returns False. This object does not implement sorting.

    Public ReadOnly Property SupportsSorting() As Boolean Implements System.ComponentModel.IBindingList.SupportsSorting
        Get
            Return False
        End Get
    End Property

#End Region
End Class
