Imports System.Windows.Forms
Imports System.Drawing
Public Class DiagnosenDataGridTextColumn
    Inherits DataGridTextBoxColumn

    Private m_Liste As DiagnosenDataGridListe

    Public Sub New(ByVal xListe As DiagnosenDataGridListe)
        m_Liste = xListe
    End Sub
    Protected Overloads Overrides Sub Paint(ByVal g As System.Drawing.Graphics, ByVal bounds As System.Drawing.Rectangle, ByVal source As System.Windows.Forms.CurrencyManager, ByVal rowNum As Integer)
        Paint(g, bounds, [source], rowNum, False)
    End Sub

    Protected Overloads Overrides Sub Paint(ByVal g As System.Drawing.Graphics, ByVal bounds As System.Drawing.Rectangle, ByVal source As System.Windows.Forms.CurrencyManager, ByVal rowNum As Integer, ByVal alignToRight As Boolean)
        Paint(g, bounds, [source], rowNum, Nothing, Nothing, False)
    End Sub

    Protected Overloads Overrides Sub Paint(ByVal g As System.Drawing.Graphics, ByVal bounds As System.Drawing.Rectangle, ByVal source As System.Windows.Forms.CurrencyManager, ByVal rowNum As Integer, ByVal backBrush As System.Drawing.Brush, ByVal foreBrush As System.Drawing.Brush, ByVal alignToRight As Boolean)
        Dim Text As String = CType(GetColumnValueAtRow([source], rowNum), System.String)
        Dim Itm As DiagnosenDataGridItem = m_Liste.Item(rowNum)
        Dim DefaultText As String = Itm.Diagnose.Text
        If Text <> DefaultText Then
            MyBase.Paint(g, bounds, [source], rowNum, SystemBrushes.Window, New SolidBrush(Color.Red), False)
        Else
            MyBase.Paint(g, bounds, [source], rowNum, SystemBrushes.Window, SystemBrushes.WindowText, False)
        End If

    End Sub
End Class
