Imports System.Drawing
Imports System.Windows.Forms
Public Class frm_DiagnosenBearbeiten
    Private Liste_Diagnosen As DiagnosenListe
    Private Liste_Diagnosen_Kopien As List(Of Diagnose)
    Private Initialisierung As Boolean = False
    Private ListBoxAktualisierung As Boolean = False
    Private ListboxWechsel As Boolean = False
    Private AppName As String = ""
    Private DataGridListe As DiagnosenDataGridListe


    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.

    End Sub
    Public Sub New(ByVal DataGridListe As DiagnosenDataGridListe)

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        Me.Text = AppName & " - Diagnosen bearbeiten"
        Me.DataGridListe = DataGridListe
        Liste_Diagnosen = DataGridListe.Diagnosen
        Weitere_Initialisierung()
    End Sub

    Private Sub Weitere_Initialisierung()
        Liste_Diagnosen_Kopien = New List(Of Diagnose)
        For Each D As Diagnose In Liste_Diagnosen
            Dim C As New DiagnoseCopy(D, Liste_Diagnosen.NullDiagnose, DataGridListe)
            ListBoxDiagnosen.Items.Add(C)
        Next
        ListBoxDiagnosen.SelectedIndex = 0
    End Sub
    Private Class DiagnoseCopy
        Public Diagnose As Diagnose
        Public DiagnoseKopie As Diagnose
        Public EditAllowed As Boolean = True
        Public Changed As Boolean = False
        Public Sub New()
            Diagnose = Nothing
            DiagnoseKopie = New Diagnose("", "Neue Diagnose")
        End Sub
        Public Sub New(ByVal D As Diagnose, ByVal NullDiagnose As Diagnose, ByVal DGListe As DiagnosenDataGridListe)
            Diagnose = D
            DiagnoseKopie = New Diagnose(D.ICD, D.Text)
            If D Is NullDiagnose Then
                EditAllowed = False
            Else
                For Each Itm As DiagnosenDataGridItem In DGListe
                    If Itm.Diagnose Is D Then
                        EditAllowed = False
                        Exit For
                    End If
                Next
            End If
        End Sub
        Property ICD() As String
            Get
                Return DiagnoseKopie.ICD
            End Get
            Set(ByVal Value As String)
                DiagnoseKopie.ICD = Value
                Changed = True
            End Set
        End Property
        Property Text() As String
            Get
                Return DiagnoseKopie.Text
            End Get
            Set(ByVal Value As String)
                DiagnoseKopie.Text = Value
                Changed = True
            End Set
        End Property
        Public Overrides Function ToString() As String
            Return ICD & " " & Text
        End Function
    End Class

    Private Sub ListBoxDiagnosen_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListBoxDiagnosen.SelectedIndexChanged
        If ListBoxAktualisierung Then Exit Sub
        Initialisierung = True
        Dim D As DiagnoseCopy = ListBoxDiagnosen.SelectedItem
        Me.TextBoxICD.Text = D.ICD
        Me.TextBoxText.Text = D.Text

        Me.TextBoxICD.Enabled = D.EditAllowed
        Me.TextBoxText.Enabled = D.EditAllowed
        Me.BtnLschen.Enabled = D.EditAllowed

        Initialisierung = False
    End Sub

    Private Sub TextBoxICD_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxICD.TextChanged
        If Initialisierung Then Exit Sub
        Dim D As DiagnoseCopy = ListBoxDiagnosen.SelectedItem
        D.ICD = Me.TextBoxICD.Text
        ListBoxAuffrischen()
    End Sub

    Private Sub TextBoxText_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxText.TextChanged
        If Initialisierung Then Exit Sub
        Dim D As DiagnoseCopy = ListBoxDiagnosen.SelectedItem
        D.Text = Me.TextBoxText.Text
        ListBoxAuffrischen()
    End Sub
    Private Sub ListBoxAuffrischen()
        ListBoxAktualisierung = True
        Dim Merkindex As Integer = ListBoxDiagnosen.SelectedIndex
        Dim Merkitem As DiagnoseCopy = ListBoxDiagnosen.SelectedItem
        ListBoxDiagnosen.Items.Remove(Merkitem)
        ListBoxDiagnosen.Items.Insert(Merkindex, Merkitem)
        ListBoxDiagnosen.SelectedIndex = Merkindex

        ListBoxAktualisierung = False
    End Sub
 
    Private Sub ButtonNeu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonNeu.Click
        Dim D As New DiagnoseCopy
        ListBoxDiagnosen.Items.Add(D)
        ListBoxDiagnosen.SelectedItem = D
    End Sub

    Private Sub BtnLschen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnLschen.Click
        If System.Windows.Forms.MessageBox.Show("Diese Diagnose wirklich lschen?", AppName, Windows.Forms.MessageBoxButtons.YesNo, Windows.Forms.MessageBoxIcon.Question) = Windows.Forms.DialogResult.No Then
            Exit Sub
        End If

        ListBoxAktualisierung = True
        Dim Merkindex As Integer = ListBoxDiagnosen.SelectedIndex
        Dim Merkitem As DiagnoseCopy = ListBoxDiagnosen.SelectedItem
        ListBoxDiagnosen.Items.Remove(Merkitem)
        ListBoxAktualisierung = False

        If ListBoxDiagnosen.Items.Count > Merkindex + 1 Then
            ListBoxDiagnosen.SelectedIndex = Merkindex
        Else
            ListBoxDiagnosen.SelectedIndex = Merkindex - 1
        End If
    End Sub


    Private Sub ButtonOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonOK.Click
        Dim Geaendert As Boolean = False

        For I As Integer = Liste_Diagnosen.Count - 1 To 0 Step -1
            Dim D As Diagnose = Liste_Diagnosen(I)
            Dim SuchKopie As DiagnoseCopy = Nothing
            For Each DC As DiagnoseCopy In Me.ListBoxDiagnosen.Items
                If DC.Diagnose Is D Then
                    SuchKopie = DC
                    Exit For
                End If
            Next
            If IsNothing(SuchKopie) Then
                Liste_Diagnosen.RemoveAt(I)
                Geaendert = True
            Else
                If SuchKopie.Changed Then
                    D.ICD = SuchKopie.DiagnoseKopie.ICD
                    D.Text = SuchKopie.DiagnoseKopie.Text
                    Geaendert = True
                End If
            End If
        Next

        For Each S1Kopie As DiagnoseCopy In Me.ListBoxDiagnosen.Items
            If IsNothing(S1Kopie.Diagnose) Then
                Liste_Diagnosen.Add(S1Kopie.DiagnoseKopie)
                Geaendert = True
            End If
        Next
        If Geaendert Then
            Liste_Diagnosen.Speichern()
            Liste_Diagnosen.Aenderung_Mitteilen()
        End If
    End Sub
    Private Sub ButtonEinfuegen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonEinfuegen.Click
        Dim Texte(1) As String
        Try
            Dim iData As IDataObject = Clipboard.GetDataObject()
            If iData.GetDataPresent(DataFormats.Text) Then
                Dim GText As String = iData.GetData("System.String", True).ToString()
                Dim Startzahl As Integer = GText.IndexOf(" ")
                Dim Teil1 = GText.Substring(0, Startzahl).Trim
                Dim Teil2 As String = GText.Substring(Startzahl).Trim
                Dim D As New Diagnose(Teil1, Teil2)
                Dim Cp As New DiagnoseCopy
                Cp.DiagnoseKopie = D

                Me.ListBoxDiagnosen.Items.Add(Cp)
                Me.ListBoxDiagnosen.SelectedItem = Cp
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message, AppName, MessageBoxButtons.OK, MessageBoxIcon.Information)
        End Try
    End Sub


End Class