Public Class KontenAuswahl
    Private m_Path As String
    Private Liste_Konten As KontoListe
    Private Initialisierung As Boolean = False
    ReadOnly Property AktuellesKonto() As Konto
        Get
            Return Liste_Konten.Aktuelles_Konto
        End Get
    End Property
    Property LabelsVisible() As Boolean
        Get
            Return Me.PanelLabels.Visible
        End Get
        Set(ByVal value As Boolean)
            Me.PanelLabels.Visible = value
        End Set
    End Property
    Public Function ToRechnungsTextParagraph(ByVal Betrag_Ueberweisung As Decimal, ByVal Nr_Rechng As String, ByVal EndDatum As DateTime) As TextParagraph
        Dim P As New TextParagraph
        P.Alignment = ParagraphAlignments.Block

        P.TextEintraege.Add(New TextEintrag("Bitte berweisen Sie den Rechnungsbetrag in Hhe von"))
        P.TextEintraege.Add(New TextEintrag(Format(Betrag_Ueberweisung, "c"), TextFormats.Bold))
        P.TextEintraege.Add(New TextEintrag("unter Angabe der Rechnungsnummer"))
        P.TextEintraege.Add(New TextEintrag(Nr_Rechng, TextFormats.Bold))
        P.TextEintraege.Add(New TextEintrag("bis zum"))
        P.TextEintraege.Add(New TextEintrag(Format(EndDatum, "d"), TextFormats.Bold))
        P.TextEintraege.Add(New TextEintrag("auf mein"))

        Return P
    End Function
    Public Function ToKontoTable() As Table
        Dim Tabkto As New Table(3, 2)
        Tabkto.Cells(0, 0).TextEintraege.Add(New TextEintrag("Konto Nummer"))
        Tabkto.Cells(1, 0).TextEintraege.Add(New TextEintrag("BLZ"))
        Tabkto.Cells(2, 0).TextEintraege.Add(New TextEintrag("bei der"))
        Tabkto.Cells(0, 1).TextEintraege.Add(New TextEintrag(Me.AktuellesKonto.KtoNr, TextFormats.Bold))
        Tabkto.Cells(1, 1).TextEintraege.Add(New TextEintrag(Me.AktuellesKonto.BLZ, TextFormats.Bold))
        Tabkto.Cells(2, 1).TextEintraege.Add(New TextEintrag(Me.AktuellesKonto.Bank, TextFormats.Bold))
        Return Tabkto
    End Function

    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
    End Sub
    Public Sub SetVorlagenPfad(ByVal Pfad As String)
        m_Path = Pfad & "\Konten.xml"
        Liste_Konten = New KontoListe(m_Path)
        For Each Kto As Konto In Liste_Konten
            Me.ComboBoxKonten.Items.Add(Kto)
        Next
        Me.ComboBoxKonten.SelectedItem = Liste_Konten.Aktuelles_Konto
    End Sub

    Public Sub Speichern()
        Liste_Konten.Save()
    End Sub
    Private Sub ComboBoxKonten_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxKonten.SelectedIndexChanged
        If ComboBoxKonten.SelectedIndex = -1 Then Exit Sub
        If Not Liste_Konten.Aktuelles_Konto Is ComboBoxKonten.SelectedItem Then
            Liste_Konten.Aktuelles_Konto = ComboBoxKonten.SelectedItem
        End If
        Konto_Anzeigen()
    End Sub
    Private Sub Konto_Anzeigen()
        Initialisierung = True
        Me.TextBoxBank.Text = Liste_Konten.Aktuelles_Konto.Bank
        Me.TextBoxBLZ.Text = Liste_Konten.Aktuelles_Konto.BLZ
        Me.TextBoxKtoNr.Text = Liste_Konten.Aktuelles_Konto.KtoNr
        Initialisierung = False
    End Sub

    Private Sub TextBoxKtoNr_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxKtoNr.TextChanged
        If Initialisierung Then Exit Sub
        Liste_Konten.Aktuelles_Konto.KtoNr = TextBoxKtoNr.Text.Trim
    End Sub

    Private Sub TextBoxBLZ_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxBLZ.TextChanged
        If Initialisierung Then Exit Sub
        Liste_Konten.Aktuelles_Konto.BLZ = TextBoxBLZ.Text.Trim
    End Sub

    Private Sub TextBoxBank_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxBank.TextChanged
        If Initialisierung Then Exit Sub
        Liste_Konten.Aktuelles_Konto.Bank = TextBoxBank.Text.Trim
    End Sub
    Public Sub KontenBearbeiten()
        Dim KTL As KontoListe = Liste_Konten.Clone
        Dim frm As New frm_Kontenbearbeiten(KTL)
        If frm.ShowDialog = Windows.Forms.DialogResult.OK Then
            ComboBoxKonten.Items.Clear()
            Liste_Konten = KTL
            Me.ComboBoxKonten.Items.AddRange(Liste_Konten.ToArray)
            Me.ComboBoxKonten.SelectedItem = Liste_Konten.Aktuelles_Konto
            Liste_Konten.Save()
        End If
    End Sub
    Public Sub Konto_Von_Aussen_Einstellen(ByVal KtoName As String)
        Dim SuchKonto As Konto = Nothing
        For Each Kto As Konto In ComboBoxKonten.Items
            If Kto.Name = KtoName Then
                SuchKonto = Kto
                Exit For
            End If
        Next
        If SuchKonto IsNot Nothing Then
            If Not SuchKonto Is ComboBoxKonten.SelectedItem Then
                ComboBoxKonten.SelectedItem = SuchKonto
            End If
        End If
    End Sub
End Class
