Imports System.Xml
Public Class KontoListe
    Inherits List(Of Konto)
    Private m_Aktuelles_Konto As Konto = New Konto
    Private m_Path As String = ""
    Property Path() As String
        Get
            Return m_Path
        End Get
        Set(ByVal Value As String)
            m_Path = Value
        End Set
    End Property
    Public Sub New()

    End Sub
    Public Sub New(ByVal Path As String)
        m_Path = Path
        If IO.File.Exists(m_Path) Then
            Dim reader As XmlTextReader = New XmlTextReader(m_Path)

            reader.WhitespaceHandling = WhitespaceHandling.None
            Dim xmlDoc As XmlDocument = New XmlDocument
            xmlDoc.Load(reader)
            reader.Close()
            Dim xnod As XmlNode = xmlDoc.DocumentElement
            Dim xKn As XmlNode
            For Each xKn In xnod.ChildNodes
                If xKn.Name = "Liste_Konten" Then
                    For Each Kn As XmlNode In xKn.ChildNodes
                        If Kn.Name = "Konto" Then
                            Dim Kto As New Konto(Kn)
                            Me.Add(Kto)
                        End If
                    Next
                    Exit For
                End If
            Next
            For Each xKn In xnod.ChildNodes
                If xKn.Name = "Aktuelles_Konto" Then
                    m_Aktuelles_Konto = Me.Item(CInt(xKn.Attributes("Nr").Value))
                    Exit For
                End If
            Next
        Else
            Me.Add(m_Aktuelles_Konto)
        End If

    End Sub
    Public Sub Save()
        Dim writer As XmlTextWriter = New XmlTextWriter(Path, System.Text.Encoding.UTF8)
        writer.WriteStartDocument(True)

        writer.WriteStartElement("Elemente")

        writer.WriteStartElement("Liste_Konten")
        For Each Kto As Konto In Me
            Kto.ToXML(writer)
        Next
        writer.WriteEndElement()

        writer.WriteStartElement("Aktuelles_Konto")
        writer.WriteAttributeString("Nr", Me.IndexOf(m_Aktuelles_Konto).ToString)
        writer.WriteEndElement()

        writer.WriteEndElement()
        writer.WriteEndDocument()
        writer.Close()

    End Sub
    Public Function Clone() As Object
        Dim Lst As New KontoListe
        Lst.Path = Me.Path
        For Each Kto As Konto In Me
            Dim NKto As Konto = Kto.Clone
            Lst.Add(NKto)
            If Kto Is m_Aktuelles_Konto Then
                Lst.Aktuelles_Konto = NKto
            End If
        Next
        Return Lst
    End Function
    Property Aktuelles_Konto() As Konto
        Get
            Return m_Aktuelles_Konto
        End Get
        Set(ByVal Value As Konto)
            m_Aktuelles_Konto = Value
        End Set
    End Property
End Class
