Public Class PKVLeistungsDataGrid
    Inherits System.Windows.Forms.UserControl
    Friend WithEvents LL As PKVLeistungDataGridListe
    Private DGTS As PKVLeistungDataGridTableStyle

    Private WithEvents ColDatum As DataGridDatumColumn
    Private WithEvents ColEintrag As PKVLeistungDataGridZifferAuswahlColumn
    Private WithEvents ColText As PKVLeistungDataGridTextColumn
    Private WithEvents ColPunktzahl As System.Windows.Forms.DataGridTextBoxColumn
    Private WithEvents ColFaktor As PKVLeistungDataGridFaktorColumn
    Private WithEvents ColBetrag As System.Windows.Forms.DataGridTextBoxColumn

    Private Initialized As Boolean = False
    Private m_minWidth As Integer = 360

    Private m_Zeilenzahl As Integer = 0
    Public Event Zeilen_geaendert()
    ReadOnly Property Zeilenzahl() As Integer
        Get
            Return m_Zeilenzahl
        End Get
    End Property

    Private m_Summe As Decimal = CDec(0)
    Public Event Summe_geaendert()
    ReadOnly Property Summe() As Decimal
        Get
            Return m_Summe
        End Get
    End Property
    WriteOnly Property MaxFactor() As Decimal
        Set(ByVal Value As Decimal)
            LL.MaxFactor = Value
            Berechnen()
        End Set
    End Property
    ReadOnly Property Liste() As PKVLeistungDataGridListe
        Get
            Return LL
        End Get
    End Property
    Public Sub Leistungen_Bearbeiten()
        Me.LL.Leistungen_Bearbeiten()
    End Sub
    Public Function ToTable(ByVal Summenrechner As SummenBerechnerFuerOstAbschlag, ByVal Extras As PostenDataset.PostenlisteDataTable) As Table
        Dim Liste_Datum As New List(Of DateTime)
        For Each itm As PKVLeistungDataGridItem In LL
            If Not Liste_Datum.Contains(itm.Datum) Then
                Liste_Datum.Add(itm.Datum)
            End If
        Next
        Liste_Datum.Sort()

        Dim Liste_Vorstellung(Liste_Datum.Count - 1) As List(Of PKVLeistungDataGridItem)
        For I As Integer = 0 To Liste_Datum.Count - 1
            Liste_Vorstellung(I) = New List(Of PKVLeistungDataGridItem)
        Next
        For Each itm As PKVLeistungDataGridItem In LL
            Liste_Vorstellung(Liste_Datum.IndexOf(itm.Datum)).Add(itm)
        Next

        Dim ExtraBetrag As Decimal = 0D
        Dim ExtraZeilen As Integer = 0
        If Extras.Rows.Count > 0 Then
            For Each Rw As PostenDataset.PostenlisteRow In Extras
                ExtraBetrag += Rw.Betrag
            Next
        End If

        If ExtraBetrag <> 0 Then
            ExtraZeilen = 1
            For Each Rw As PostenDataset.PostenlisteRow In Extras
                ExtraZeilen += 1
            Next
        End If


        Dim Tab As Table
        If Summenrechner.OstAbschlag_verwenden Then
            Tab = New Table(LL.Count + 4 + ExtraZeilen, 5)
        Else
            Tab = New Table(LL.Count + 2 + ExtraZeilen, 5)
        End If

        Tab.Cells(0, 0).TextEintraege.Add(New TextEintrag("Datum"))
        Tab.Cells(0, 1).TextEintraege.Add(New TextEintrag("Ziffer"))
        Tab.Cells(0, 2).TextEintraege.Add(New TextEintrag("Text"))
        Tab.Cells(0, 3).TextEintraege.Add(New TextEintrag("Faktor"))
        Tab.Cells(0, 4).TextEintraege.Add(New TextEintrag("Betrag"))

        Dim ZeilenZaehler As Integer = 1

        For I As Integer = 0 To Liste_Datum.Count - 1
            Dim Dat As Date = Liste_Datum(I)
            Tab.Cells(ZeilenZaehler, 0).TextEintraege.Add(New TextEintrag(Format(Dat, "d")))

            For Each itm1 As PKVLeistungDataGridItem In Liste_Vorstellung(I)
                Tab.Cells(ZeilenZaehler, 1).TextEintraege.Add(New TextEintrag(itm1.Leistung.Ziffer))
                Tab.Cells(ZeilenZaehler, 2).TextEintraege.Add(New TextEintrag(itm1.Text))

                If itm1.Leistung.IstFestWert Then
                    Tab.Cells(ZeilenZaehler, 3).TextEintraege.Add(New TextEintrag("-"))
                Else
                    Tab.Cells(ZeilenZaehler, 3).TextEintraege.Add(New TextEintrag(itm1.Faktor.ToString))
                End If
                Tab.Cells(ZeilenZaehler, 4).TextEintraege.Add(New TextEintrag(Format(itm1.Betrag, "c")))
                ZeilenZaehler += 1
            Next
        Next


      



        If Summenrechner.OstAbschlag_verwenden Then
            'OstAbschlag = Math.Round((Zwischensumme / CDec(10)), 2)
            'Rechnungsbetrag = Zwischensumme - OstAbschlag
            Tab.Cells(ZeilenZaehler, 0).TextEintraege.Add(New TextEintrag("Zwischensumme", TextFormats.Bold))
            Tab.Cells(ZeilenZaehler, 4).TextEintraege.Add(New TextEintrag(Format(Summenrechner.SummeOhneOstAbschlag, "c"), TextFormats.Bold))
            Tab.Cells(ZeilenZaehler + 1, 0).TextEintraege.Add(New TextEintrag("10% Ostabschlag"))
            Tab.Cells(ZeilenZaehler + 1, 4).TextEintraege.Add(New TextEintrag("-" & Format(Summenrechner.OstAbschlag, "c")))
            If ExtraBetrag <> 0 Then
                ZeilenZaehler += 1
                Tab.Cells(ZeilenZaehler + 1, 0).TextEintraege.Add(New TextEintrag("Zwischensumme", TextFormats.Bold))
                Tab.Cells(ZeilenZaehler + 1, 4).TextEintraege.Add(New TextEintrag(Format(Summenrechner.Ergebnis, "c")))

                For Each Rw As PostenDataset.PostenlisteRow In Extras
                    ZeilenZaehler += 1
                    Tab.Cells(ZeilenZaehler + 1, 0).TextEintraege.Add(New TextEintrag(Rw.Posten))
                    Tab.Cells(ZeilenZaehler + 1, 4).TextEintraege.Add(New TextEintrag(Format(Rw.Betrag, "c")))
                Next
            End If

            Tab.Cells(ZeilenZaehler + 2, 0).TextEintraege.Add(New TextEintrag("Gesamt", TextFormats.Bold))
            Tab.Cells(ZeilenZaehler + 2, 4).TextEintraege.Add(New TextEintrag(Format(Summenrechner.Ergebnis + ExtraBetrag, "c"), TextFormats.Bold))
            Tab.SetHorizontalLine(0, True, TableCellBorderStyles.Einfach)
            Tab.SetHorizontalLine(ZeilenZaehler, False, TableCellBorderStyles.Einfach)
            Tab.SetHorizontalLine(ZeilenZaehler + 2, False, TableCellBorderStyles.Einfach)
            Tab.Cells(ZeilenZaehler + 2, 4).Borders.BottomBorder = TableCellBorderStyles.Doppelt
        Else
            If ExtraBetrag <> 0 Then

                Tab.Cells(ZeilenZaehler, 0).TextEintraege.Add(New TextEintrag("Zwischensumme", TextFormats.Bold))
                Tab.Cells(ZeilenZaehler, 4).TextEintraege.Add(New TextEintrag(Format(Summenrechner.Ergebnis, "c")))
                ZeilenZaehler += 1
                For Each Rw As PostenDataset.PostenlisteRow In Extras

                    Tab.Cells(ZeilenZaehler, 0).TextEintraege.Add(New TextEintrag(Rw.Posten))
                    Tab.Cells(ZeilenZaehler, 4).TextEintraege.Add(New TextEintrag(Format(Rw.Betrag, "c")))
                    ZeilenZaehler += 1
                Next
            End If

            Tab.Cells(ZeilenZaehler, 0).TextEintraege.Add(New TextEintrag("Gesamt", TextFormats.Bold))
            Tab.Cells(ZeilenZaehler, 4).TextEintraege.Add(New TextEintrag(Format(Summenrechner.Ergebnis + ExtraBetrag, "c"), TextFormats.Bold))
            Tab.SetHorizontalLine(0, True, TableCellBorderStyles.Einfach)
            Tab.SetHorizontalLine(ZeilenZaehler, False, TableCellBorderStyles.Einfach)
            Tab.Cells(ZeilenZaehler, 4).Borders.BottomBorder = TableCellBorderStyles.Doppelt
        End If


        For I As Integer = 0 To Tab.NumRows - 1
            Tab.Cells(I, 4).Paragraph.Alignment = ParagraphAlignments.Right
            Tab.Cells(I, 4).VerticalAlignment = TableCellVerticalAlignments.Bottom
        Next
        Return Tab
    End Function
    Public Sub Initialisieren(ByVal Vorlagenpfad As String)
        LL = New PKVLeistungDataGridListe(Vorlagenpfad)
        Me.DataGrid1.DataSource = LL
        DGTS = New PKVLeistungDataGridTableStyle(LL)
        Me.DataGrid1.TableStyles.Add(DGTS)
        ColDatum = DGTS.ColDatum
        ColEintrag = DGTS.ColEintrag
        ColText = DGTS.ColText
        ColPunktzahl = DGTS.ColPunktzahl
        ColFaktor = DGTS.ColFaktor
        ColBetrag = DGTS.ColBetrag
        Standards_Einstellen()
        Initialized = True
    End Sub
#Region " Vom Windows Form Designer generierter Code "

    Public Sub New()
        MyBase.New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen
    End Sub

    'UserControl berschreibt den Lschvorgang zum Bereinigen der Komponentenliste.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Fr Windows Form-Designer erforderlich
    Private components As System.ComponentModel.IContainer

    'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
    'Sie kann mit dem Windows Form-Designer modifiziert werden.
    'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
    Friend WithEvents Panel1 As System.Windows.Forms.Panel
    Friend WithEvents DataGrid1 As System.Windows.Forms.DataGrid
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Panel1 = New System.Windows.Forms.Panel
        Me.DataGrid1 = New System.Windows.Forms.DataGrid
        Me.Panel1.SuspendLayout()
        CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'Panel1
        '
        Me.Panel1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.Panel1.Controls.Add(Me.DataGrid1)
        Me.Panel1.Dock = System.Windows.Forms.DockStyle.Fill
        Me.Panel1.Location = New System.Drawing.Point(0, 0)
        Me.Panel1.Name = "Panel1"
        Me.Panel1.Size = New System.Drawing.Size(600, 128)
        Me.Panel1.TabIndex = 0
        '
        'DataGrid1
        '
        Me.DataGrid1.BorderStyle = System.Windows.Forms.BorderStyle.None
        Me.DataGrid1.CaptionVisible = False
        Me.DataGrid1.DataMember = ""
        Me.DataGrid1.Dock = System.Windows.Forms.DockStyle.Fill
        Me.DataGrid1.HeaderForeColor = System.Drawing.SystemColors.ControlText
        Me.DataGrid1.Location = New System.Drawing.Point(0, 0)
        Me.DataGrid1.Name = "DataGrid1"
        Me.DataGrid1.Size = New System.Drawing.Size(598, 126)
        Me.DataGrid1.TabIndex = 0
        '
        'PKVLeistungsDataGrid
        '
        Me.Controls.Add(Me.Panel1)
        Me.Name = "PKVLeistungsDataGrid"
        Me.Size = New System.Drawing.Size(600, 128)
        Me.Panel1.ResumeLayout(False)
        CType(Me.DataGrid1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region
    Private Sub Standards_Einstellen()
        'Breite fr alles auer Text =355+Rahmen=357
        Initialized = False
        ColDatum.Width = 75
        ColEintrag.Width = 50
        ColText.Width = Me.Width - 357
        ColPunktzahl.Width = 80
        ColFaktor.Width = 40
        ColBetrag.Width = 75
        DGTS.ColEintrag.DropDownWidth = Me.Width - 2 - 35 - ColDatum.Width
        Initialized = True
    End Sub

    Private Sub PKVLeistungsDataGrid_SizeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.SizeChanged
        If Me.Width < m_minWidth Then
            Me.Width = m_minWidth
        End If
        If Not Initialized Then Exit Sub
        Standards_Einstellen()
    End Sub
    Private Sub ColDatum_WidthChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ColDatum.WidthChanged
        If Not Initialized Then Exit Sub
        TextBreite_Einstellen()
    End Sub
    Private Sub ColEintrag_WidthChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ColEintrag.WidthChanged
        If Not Initialized Then Exit Sub
        TextBreite_Einstellen()
    End Sub
    Private Sub TextBreite_Einstellen()
        'ColText.Width = Me.Width - ColDatum.Width - ColEintrag.Width - 35 - 2
        DGTS.ColEintrag.DropDownWidth = Me.Width - 2 - 35 - ColDatum.Width
    End Sub

    Private Sub Berechnen()

        'Dim DT As PostenDataset.PostenlisteDataTable = Me.objPostenDataset.Postenliste

        Dim GSumme As Decimal = CDec(0)
        For Each Itm As PKVLeistungDataGridItem In LL
            GSumme += Itm.Betrag
        Next

        If m_Summe <> GSumme Then
            m_Summe = GSumme
            RaiseEvent Summe_geaendert()
        End If
        If m_Zeilenzahl <> LL.Count Then
            m_Zeilenzahl = LL.Count
            RaiseEvent Zeilen_geaendert()
        End If

    End Sub
    Private Sub DataGrid1_CurrentCellChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles DataGrid1.CurrentCellChanged
        'Berechnen()
    End Sub

    Private Sub LL_ListChanged(ByVal sender As Object, ByVal e As System.ComponentModel.ListChangedEventArgs) Handles LL.ListChanged
        Berechnen()
    End Sub
End Class
