Public Class PostenDataGridView
    Public Event Summe_Geaendert()
    Private m_Summe As Decimal = CDec(0)
    Private WithEvents m_DT As PostenDataset.PostenlisteDataTable
    Private m_Initialisierung As Boolean = False
    ReadOnly Property Summe() As Decimal
        Get
            Return m_Summe
        End Get
    End Property
    ReadOnly Property Zeilenzahl() As Integer
        Get
            Dim DT As PostenDataset.PostenlisteDataTable = Me.objPostenDataset.Postenliste
            Return DT.Rows.Count
        End Get
    End Property
    ReadOnly Property PostenlisteDataTable() As PostenDataset.PostenlisteDataTable
        Get
            Return Me.objPostenDataset.Postenliste
        End Get
    End Property
    Public Function ToTable(ByVal Mehrwertsteuersatz As Decimal) As Table
        Dim Tab As Table

        Dim DT As PostenDataset.PostenlisteDataTable = Me.objPostenDataset.Postenliste
        If Mehrwertsteuersatz = 0D Then
            Tab = New Table(DT.Rows.Count + 2, 2)
        Else
            Tab = New Table(DT.Rows.Count + 3, 2)
        End If


        Tab.Cells(0, 0).TextEintraege.Add(New TextEintrag("Posten"))
        Tab.Cells(0, 1).TextEintraege.Add(New TextEintrag("Betrag"))

        Dim ZeilenPos As Integer = 1
        For Each DR As PostenDataset.PostenlisteRow In DT.Rows
            If Not DR.HasErrors Then
                If Not DR.IsPostenNull Then
                    Tab.Cells(ZeilenPos, 0).TextEintraege.Add(New TextEintrag(DR.Posten))
                End If
                If Not DR.IsBetragNull Then
                    Tab.Cells(ZeilenPos, 1).TextEintraege.Add(New TextEintrag(Format(DR.Betrag, "c")))
                Else
                    Tab.Cells(ZeilenPos, 1).TextEintraege.Add(New TextEintrag(Format(CDec(0), "c")))
                End If
            End If
            ZeilenPos += 1
        Next
        If Mehrwertsteuersatz = 0D Then
            Tab.SetHorizontalLine(ZeilenPos, False, TableCellBorderStyles.Einfach)
            Tab.Cells(ZeilenPos, 0).TextEintraege.Add(New TextEintrag("Gesamtbetrag", TextFormats.Bold))
            Tab.Cells(ZeilenPos, 1).TextEintraege.Add(New TextEintrag(Format(m_Summe, "c"), TextFormats.Bold))
            Tab.Cells(ZeilenPos, 1).Borders.BottomBorder = TableCellBorderStyles.Doppelt
            ZeilenPos += 1
        Else
            Tab.SetHorizontalLine(ZeilenPos, False, TableCellBorderStyles.Einfach)
            Tab.Cells(ZeilenPos, 0).TextEintraege.Add(New TextEintrag("Mehrwertsteuer " & Mehrwertsteuersatz.ToString & "%"))
            Dim Mwst As Decimal = m_Summe / CDec(100) * Mehrwertsteuersatz
            Tab.Cells(ZeilenPos, 1).TextEintraege.Add(New TextEintrag(Format(Mwst, "c")))
            Dim Gesamtsumme As Decimal = Mwst + m_Summe
            ZeilenPos += 1
            Tab.Cells(ZeilenPos, 0).TextEintraege.Add(New TextEintrag("Gesamtbetrag", TextFormats.Bold))
            Tab.Cells(ZeilenPos, 1).TextEintraege.Add(New TextEintrag(Format(Gesamtsumme, "c"), TextFormats.Bold))
            Tab.Cells(ZeilenPos, 1).Borders.BottomBorder = TableCellBorderStyles.Doppelt
            ZeilenPos += 1
        End If

        For I As Integer = 0 To Tab.NumRows - 1
            Tab.Cells(I, 1).Paragraph.Alignment = ParagraphAlignments.Right
            Tab.Cells(I, 1).VerticalAlignment = TableCellVerticalAlignments.Bottom
        Next
        Return Tab
    End Function

    Private Sub Berechnen()
        'Dim DT As PostenDataset.PostenlisteDataTable = Me.objPostenDataset.Postenliste

        Dim GSumme As Decimal = CDec(0)
        For Each DR As PostenDataset.PostenlisteRow In m_DT.Rows
            If Not DR.HasErrors Then
                If Not DR.IsBetragNull Then
                    GSumme += DR.Betrag
                End If
            End If
        Next

        If m_Summe <> GSumme Then
            m_Summe = GSumme
            RaiseEvent Summe_Geaendert()
        End If
    End Sub



    Public Sub New()
        m_Initialisierung = True
        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        m_Initialisierung = False
        m_DT = Me.objPostenDataset.Postenliste
    End Sub

    Private Sub m_DT_PostenlisteRowChanged(ByVal sender As Object, ByVal e As PostenDataset.PostenlisteRowChangeEvent) Handles m_DT.PostenlisteRowChanged
        If m_Initialisierung Then Exit Sub
        Berechnen()
    End Sub

    Private Sub m_DT_PostenlisteRowDeleted(ByVal sender As Object, ByVal e As PostenDataset.PostenlisteRowChangeEvent) Handles m_DT.PostenlisteRowDeleted
        If m_Initialisierung Then Exit Sub
        Berechnen()
    End Sub
End Class
