<Serializable()> Public Class Table
    Private m_NumColumns As Integer = 0
    Private m_NumRows As Integer = 0
    Private m_Cells(,) As TableCell
    Private m_alignment As ParagraphAlignments = ParagraphAlignments.Left
    Public Sub New(ByVal NumRows As Integer, ByVal NumColumns As Integer)
        m_NumRows = NumRows
        m_NumColumns = NumColumns
        ReDim m_Cells(NumRows - 1, NumColumns - 1)
        For I As Integer = 0 To NumRows - 1
            For J As Integer = 0 To NumColumns - 1
                m_Cells(I, J) = New TableCell
            Next
        Next
    End Sub
    Public Function Cells(ByVal RowIndex As Integer, ByVal ColumnIndex As Integer) As TableCell
        Return m_Cells(RowIndex, ColumnIndex)
    End Function
    ReadOnly Property NumColumns() As Integer
        Get
            Return m_NumColumns
        End Get
    End Property
    ReadOnly Property NumRows() As Integer
        Get
            Return m_NumRows
        End Get
    End Property
    Property Alignment() As ParagraphAlignments
        Get
            Return m_alignment
        End Get
        Set(ByVal Value As ParagraphAlignments)
            m_alignment = Value
        End Set
    End Property
    Public Sub SetVerticalLine(ByVal ColumnIndex As Integer, ByVal AfterColumn As Boolean, ByVal LineStyle As TableCellBorderStyles)
        For I As Integer = 0 To m_NumRows - 1
            If AfterColumn Then
                m_Cells(I, ColumnIndex).Borders.RightBorder = LineStyle
            Else
                m_Cells(I, ColumnIndex).Borders.LeftBorder = LineStyle
            End If
        Next
    End Sub
    Public Sub SetHorizontalLine(ByVal RowIndex As Integer, ByVal AfterRow As Boolean, ByVal LineStyle As TableCellBorderStyles)
        For I As Integer = 0 To m_NumColumns - 1
            If AfterRow Then
                m_Cells(RowIndex, I).Borders.BottomBorder = LineStyle
            Else
                m_Cells(RowIndex, I).Borders.TopBorder = LineStyle
            End If
        Next
    End Sub
End Class
