Public Class Arbeitsadresse
    'Die Klasse Arbeitsadresse stellt Funktionen und Optionen zum Bearbeiten einer Adresse bereit
    'Einerseits enthlt sie eine Adresse, die bearbeitet werden kann,
    'daneben stellt sie eine Funktion zur automatischen Erstellung einer Briefanrede und zum Auffllen
    'eines zugehrigen Kombinationsfelds bereit

    'Im Form "frmMain" ist gewhrleistet, dass es immer eine Instanz einer Arbeitsadresse gibt.

    Public Event Aenderung_Anschrift()
    Public Event Aenderung_Anrede()
    Public Event Aenderung_Anrede_manuell()
    Public Event Aenderung_AnredeVorschlaege()

#Region " Private Variablen "
    Private m_Liste_AnredeVorschlaege As ArrayList
    Private WithEvents m_Adresse As Adresse
    Private m_AnschriftOben As String = ""
    Private m_BasisListe_Anreden As List(Of Anrede)
    Private m_ManuellAnredeAenderung As Boolean = False
    Private m_OptimalAnrede As String = ""
#End Region

    Public Sub New(ByVal Adr As Adresse, ByVal BasisListe_Anreden As List(Of Anrede))
        m_Liste_AnredeVorschlaege = New ArrayList

        m_BasisListe_Anreden = BasisListe_Anreden
        m_Adresse = Adr

        Anschrift_Erstellen()
        Anrede_Vorschlaege_Erstellen()
    End Sub

#Region " Properties "
    ReadOnly Property Liste_AnredeVorschlaege() As ArrayList
        Get
            Return m_Liste_AnredeVorschlaege
        End Get
    End Property
    WriteOnly Property ManuellAnredeAenderung() As Boolean
        Set(ByVal Value As Boolean)
            m_ManuellAnredeAenderung = Value
        End Set
    End Property


    ReadOnly Property Adresse() As Adresse
        Get
            Return m_Adresse
        End Get
    End Property
    ReadOnly Property AnschriftOben() As String
        Get
            Return m_AnschriftOben
        End Get
    End Property

    Property Nachname() As String
        Get
            Return m_Adresse.Nachname
        End Get
        Set(ByVal Value As String)
            If Value.Trim <> m_Adresse.Nachname Then
                m_Adresse.Nachname = Value.Trim
                Anschrift_Erstellen()
                Anrede_Erstellen()
            End If
        End Set
    End Property
    Property Vorname() As String
        Get
            Return m_Adresse.Vorname
        End Get
        Set(ByVal Value As String)
            If Value.Trim <> m_Adresse.Vorname Then
                m_Adresse.Vorname = Value.Trim
                Anschrift_Erstellen()
                Anrede_Erstellen()
            End If
        End Set
    End Property
    Property Ort() As String
        Get
            Return m_Adresse.Ort
        End Get
        Set(ByVal Value As String)
            If Value.Trim <> m_Adresse.Ort Then
                m_Adresse.Ort = Value.Trim
                Anschrift_Erstellen()
            End If
        End Set
    End Property
    Property PLZ() As String
        Get
            Return m_Adresse.PLZ
        End Get
        Set(ByVal Value As String)
            If Value.Trim <> m_Adresse.PLZ Then
                m_Adresse.PLZ = Value.Trim
                Anschrift_Erstellen()
            End If
        End Set
    End Property
    Property Strasse() As String
        Get
            Return m_Adresse.Strasse
        End Get
        Set(ByVal Value As String)
            If Value.Trim <> m_Adresse.Strasse Then
                m_Adresse.Strasse = Value.Trim
                Anschrift_Erstellen()
            End If
        End Set
    End Property
    Property Firma() As String
        Get
            Return m_Adresse.Firma
        End Get
        Set(ByVal Value As String)
            If Value.Trim <> m_Adresse.Firma Then
                m_Adresse.Firma = Value.Trim
                Anschrift_Erstellen()
                Anrede_Erstellen()
            End If
        End Set
    End Property
    Property Firma1() As String
        Get
            Return m_Adresse.Firma1
        End Get
        Set(ByVal Value As String)
            If Value.Trim <> m_Adresse.Firma1 Then
                m_Adresse.Firma1 = Value.Trim
                Anschrift_Erstellen()
                Anrede_Erstellen()
            End If
        End Set
    End Property
    Property Stellung() As String
        Get
            Return m_Adresse.Stellung
        End Get
        Set(ByVal Value As String)
            If Value.Trim <> m_Adresse.Stellung Then
                m_Adresse.Stellung = Value.Trim
                Anschrift_Erstellen()
                Anrede_Erstellen()
            End If
        End Set
    End Property
    Property Telefon() As String
        Get
            Return m_Adresse.Telefon
        End Get
        Set(ByVal Value As String)
            m_Adresse.Telefon = Value.Trim
        End Set
    End Property
    Property Bemerkung() As String
        Get
            Return m_Adresse.Bemerkung
        End Get
        Set(ByVal Value As String)
            m_Adresse.Bemerkung = Value.Trim
        End Set
    End Property
    Property Geburtstag() As String
        Get
            Return m_Adresse.Geburtstag
        End Get
        Set(ByVal Value As String)
            m_Adresse.Geburtstag = Value.Trim
        End Set
    End Property
    Property Firmavoran() As Boolean
        Get
            Return m_Adresse.FirmaVoran
        End Get
        Set(ByVal Value As Boolean)
            If m_Adresse.FirmaVoran <> Value Then
                m_Adresse.FirmaVoran = Value
                Anschrift_Erstellen()
            End If
        End Set
    End Property
    Property Geschlecht() As Geschlechter
        Get
            Return m_Adresse.Geschlecht
        End Get
        Set(ByVal Value As Geschlechter)
            If m_Adresse.Geschlecht <> Value Then
                m_Adresse.Geschlecht = Value
                Anschrift_Erstellen()
                Anrede_Erstellen()
            End If
        End Set
    End Property
    Property Titel() As String
        Get
            Return m_Adresse.Titel
        End Get
        Set(ByVal Value As String)
            If m_Adresse.Titel <> Value.Trim Then
                m_Adresse.Titel = Value.Trim
                Anschrift_Erstellen()
                Anrede_Erstellen()
            End If
        End Set
    End Property
    Property Briefanrede() As String
        Get
            Return m_Adresse.Briefanrede
        End Get
        Set(ByVal Value As String)
            If m_Adresse.Briefanrede <> Value.Trim Then
                m_Adresse.Briefanrede = Value.Trim
                If Not m_ManuellAnredeAenderung Then
                    RaiseEvent Aenderung_Anrede()
                Else
                    RaiseEvent Aenderung_Anrede_manuell()
                End If
            End If
        End Set
    End Property
    Property Betreff() As String
        Get
            Return m_Adresse.Betreff
        End Get
        Set(ByVal Value As String)
            m_Adresse.Betreff = Value.Trim
        End Set
    End Property
    Property Dokumentenvorlage() As String
        Get
            Return m_Adresse.Dokumentenvorlage
        End Get
        Set(ByVal Value As String)
            m_Adresse.Dokumentenvorlage = Value.Trim
        End Set
    End Property
    Property Email() As String
        Get
            Return m_Adresse.Email
        End Get
        Set(ByVal Value As String)
            m_Adresse.Email = Value.Trim
        End Set
    End Property
    Property Fax() As String
        Get
            Return m_Adresse.Fax
        End Get
        Set(ByVal Value As String)
            m_Adresse.Fax = Value.Trim
        End Set
    End Property
    Property www() As String
        Get
            Return m_Adresse.www
        End Get
        Set(ByVal Value As String)
            m_Adresse.www = Value.Trim
        End Set
    End Property
    Property Mobil() As String
        Get
            Return m_Adresse.Mobil
        End Get
        Set(ByVal Value As String)
            m_Adresse.Mobil = Value.Trim
        End Set
    End Property
    'ReadOnly Property Schulden() As String
    '    Get
    '        Return Format(m_Adresse.Schulden, "c")
    '    End Get
    'End Property
#End Region

    Private Sub Anrede_Erstellen()
        'Dies passiert jedes Mal, wenn sich Voraussetzungen fr eine Anrede (Geschlecht, Vorname, Nachname, Titel)
        'gendert haben.
        'Die alte Anrede wird temporr in einer Variablen gespeichert
        Dim AltAnrede As String = Me.Briefanrede
        'Dann werden die neuen m_Liste_AnredeVorschlaege erstellt. 
        Anrede_Vorschlaege_Erstellen()
        'Falls die neuen m_Liste_AnredeVorschlaege die AltAnrede enthalten, 
        'wird an der Briefanrede nichts gendert.
        'wenn die AltAnrede nicht zu den neuen AmnredeVorschlgen passt, wird der beste 
        'AnredeVorschlag als Anrede ausgewhlt
        If Not m_Liste_AnredeVorschlaege.Contains(AltAnrede) Then
            Me.Briefanrede = m_OptimalAnrede
        End If

        'ToDo: berprfen, ob AltAnrede  nach ndern der m_Liste_AnredeVorschlaege angezeigt wird
    End Sub
    Private Sub Anrede_Vorschlaege_Erstellen()
        'Hier werden die neuen m_Liste_AnredeVorschlaege erstellt. 
        'Das oberste Element ist die StandardAnrede

        'Anrede_Vorschlaege_Erstellen wird nur ber die Prozedur Anrede_Erstellen aufgerufen

        Dim NeuVorschlge As New ArrayList
        m_OptimalAnrede = ""

        If m_Adresse.Geschlecht = Geschlechter.unpersnlich Then
            NeuVorschlge.Add("Sehr geehrte Damen und Herren,")
            NeuVorschlge.Add("Sehr geehrte Kollegen,")
            NeuVorschlge.Add("Liebe Kollegen,")
            m_OptimalAnrede = "Sehr geehrte Damen und Herren,"
        Else
            Dim A As Anrede, S As Anrede, Txt As String, Gefunden As Boolean = False
            Dim Testtext As String = m_Adresse.Firma & " " & m_Adresse.Firma1 & " " & m_Adresse.Stellung & " " & m_Adresse.Titel & " " & m_Adresse.Nachname

            S = New Anrede

            Dim ZM As String
            For Each A In m_BasisListe_Anreden
                If Testtext.IndexOf(A.Titel) > -1 Then
                    S = A
                    Gefunden = True
                    Exit For
                End If
                For Each Txt In A.Synonyme
                    If Testtext.IndexOf(Txt) > -1 Then
                        S = A
                        Gefunden = True
                        Exit For
                    End If
                Next
                If Gefunden Then Exit For
            Next
            If Gefunden Then
                If m_Adresse.Geschlecht = Geschlechter.mnnlich Then
                    ZM = S.AnredeMnnlich
                Else
                    ZM = S.AnredeWeiblich
                End If
                If S.MitNachname Then ZM = ZM & " " & m_Adresse.Nachname
                ZM = ZM & ","
                NeuVorschlge.Add(ZM)
                m_OptimalAnrede = ZM
            End If
            If m_Adresse.Nachname <> "" Then
                If m_Adresse.Geschlecht = Geschlechter.mnnlich Then
                    ZM = "Sehr geehrter Herr " & m_Adresse.Nachname & ","
                Else
                    ZM = "Sehr geehrte Frau " & m_Adresse.Nachname & ","
                End If
            Else
                If m_Adresse.Geschlecht = Geschlechter.mnnlich Then
                    ZM = "Sehr geehrter Herr,"
                Else
                    ZM = "Sehr geehrte Frau,"
                End If
            End If
            If Not NeuVorschlge.Contains(ZM) Then
                NeuVorschlge.Add(ZM)
            End If
            If m_OptimalAnrede = "" Then
                m_OptimalAnrede = ZM
            End If
            If m_Adresse.Geschlecht = Geschlechter.mnnlich Then
                ZM = "Sehr geehrter Herr Kollege,"
            Else
                ZM = "Sehr geehrte Frau Kollegin,"
            End If
            If Not NeuVorschlge.Contains(ZM) Then
                NeuVorschlge.Add(ZM)
            End If
            If m_Adresse.Vorname <> "" Then
                If m_Adresse.Geschlecht = Geschlechter.mnnlich Then
                    NeuVorschlge.Add("Lieber " & m_Adresse.Vorname & ",")
                Else
                    NeuVorschlge.Add("Liebe " & m_Adresse.Vorname & ",")
                End If
            End If
        End If

        Dim ndern As Boolean = False
        If NeuVorschlge.Count <> m_Liste_AnredeVorschlaege.Count Then
            ndern = True
        Else
            For Each xtxt As String In NeuVorschlge
                If Not m_Liste_AnredeVorschlaege.Contains(xtxt) Then
                    ndern = True
                    Exit For
                End If
            Next
        End If

        If ndern Then
            m_Liste_AnredeVorschlaege = NeuVorschlge
            RaiseEvent Aenderung_AnredeVorschlaege()
        End If

    End Sub

    Private Sub Anschrift_Erstellen()
        Dim ZM As String = "", I As Integer
        Dim Zeilen As New ArrayList

        If m_Adresse.Firma <> "" Then Zeilen.Add(m_Adresse.Firma)
        If m_Adresse.Firma1 <> "" Then Zeilen.Add(m_Adresse.Firma1)
        If m_Adresse.Stellung <> "" Then Zeilen.Add(m_Adresse.Stellung)

        If m_Adresse.Geschlecht <> Geschlechter.unpersnlich Then
            Dim txt1 As String
            If m_Adresse.Geschlecht = Geschlechter.mnnlich Then
                txt1 = "Herrn "
            Else
                txt1 = "Frau "
            End If
            If m_Adresse.Titel <> "" Then txt1 = txt1 & m_Adresse.Titel & " "
            If m_Adresse.Vorname <> "" Then txt1 = txt1 & Vorname_auswerten() & " "
            If m_Adresse.Nachname <> "" Then txt1 = txt1 & m_Adresse.Nachname
            If m_Adresse.FirmaVoran Then
                Zeilen.Add(txt1)
            Else
                Zeilen.Insert(0, txt1)
            End If
        End If

        If m_Adresse.Strasse <> "" Then Zeilen.Add(m_Adresse.Strasse)
        Zeilen.Add("")
        Dim txt2 As String = String.Empty
        If m_Adresse.PLZ <> "" Then txt2 = m_Adresse.PLZ & " "
        If m_Adresse.Ort <> "" Then txt2 = txt2 & m_Adresse.Ort

        If txt2 <> "" Then Zeilen.Add(txt2)

        For I = 0 To Zeilen.Count - 1
            ZM = ZM & Zeilen(I) & vbCrLf
        Next

        If ZM <> "" Then
            ZM = ZM.Substring(0, ZM.Length - 1)
        End If

        If m_AnschriftOben <> ZM Then
            m_AnschriftOben = ZM
            RaiseEvent Aenderung_Anschrift()
        End If
    End Sub
    Private Function Vorname_auswerten() As String
        Dim ZM As String = ""
        Dim I As Integer
        Dim Einfgen As Boolean = True

        Dim VN As String = m_Adresse.Vorname
        If VN <> "" Then
            For I = 0 To VN.Length - 1
                Select Case Asc(VN.Substring(I, 1))
                    Case 65 To 90, 97 To 122, 196, 228, 214, 246, 220, 252
                        If Einfgen Then
                            ZM = ZM & VN.Substring(I, 1).ToUpper & "."
                            Einfgen = False
                        End If
                    Case 45
                        ZM = ZM & "-"
                        Einfgen = True
                    Case Else
                        Einfgen = True
                End Select
            Next
        End If

        Return ZM
    End Function

    'Private Sub m_Adresse_Schulden_Geaendert() Handles m_Adresse.Schulden_Geaendert
    '    RaiseEvent Aenderung_Schulden()
    'End Sub
End Class
