Public Class BeschreibungGruppe
    Implements IAMBeschreibungsElement

    Private m_MenueVisible As Boolean = True

    Public Event Changed() Implements IAMBeschreibungsElement.Changed

    Private m_Children As List(Of IAMBeschreibungsElement)
    ReadOnly Property Children() As List(Of IAMBeschreibungsElement)
        Get
            Return m_Children
        End Get
    End Property

    Public Sub New()
        m_Children = New List(Of IAMBeschreibungsElement)
    End Sub

    Public ReadOnly Property Typ() As AMBeschreibungsElementTypen Implements IAMBeschreibungsElement.Typ
        Get
            Return AMBeschreibungsElementTypen.Gruppe
        End Get
    End Property

    'Visible hat Prioritt
    Public Property Visible() As Boolean Implements IAMBeschreibungsElement.MenueVisible
        Get
            Return m_MenueVisible
        End Get
        Set(ByVal value As Boolean)
            If m_MenueVisible <> value Then
                m_MenueVisible = value
                For Each El As IAMBeschreibungsElement In m_Children
                    El.MenueVisible = m_MenueVisible
                Next
            End If
        End Set
    End Property

    Public Function CreateElemente() As System.Collections.Generic.List(Of ToolStripItem) Implements IAMBeschreibungsElement.CreateElemente
        Dim Liste As New List(Of ToolStripItem)
        For Each El As IAMBeschreibungsElement In m_Children
            Liste.AddRange(El.CreateElemente.ToArray)
        Next
        'Liste.AddRange(m_Children.ToArray)
        Return Liste
    End Function

    Public Property VisibleState() As VisibleStates Implements IAMBeschreibungsElement.VisibleState
        Get

        End Get
        Set(ByVal value As VisibleStates)

        End Set
    End Property
End Class
