Imports System.Xml
Public Class Zahlung
    Inherits BriefInfo
    Implements IGeldelement

#Region " Private Variablen und Properties "
    Private m_Geldbetrag As Decimal = 0D
    Public Property Betrag() As Decimal Implements IGeldelement.Geldbetrag
        Get
            Return m_Geldbetrag
        End Get
        Set(ByVal value As Decimal)
            If m_Geldbetrag <> value Then
                m_Geldbetrag = value
                MyBase.Aenderung_Melden()
            End If
        End Set
    End Property
    Public Overrides ReadOnly Property Typ() As BriefInfoTypen
        Get
            Return BriefInfoTypen.Zahlung
        End Get
    End Property
    Public Overrides ReadOnly Property Contents() As BriefInfoContents
        Get
            Return BriefInfoContents.Geld
        End Get
    End Property
#End Region

#Region " Konstruktor und Speichern "
    Public Sub New()

    End Sub
    Public Sub New(ByVal Nd As XmlNode)
        MyBase.New(Nd)
        m_Geldbetrag = CDec(Nd.Attributes("Betrag").Value)
    End Sub
    Public Overrides Sub XMLSchreiben(ByVal writer As System.Xml.XmlTextWriter)
        MyBase.XMLSchreiben(writer)
        writer.WriteAttributeString("Betrag", m_Geldbetrag.ToString)
    End Sub
#End Region

#Region " Cloning "
    Public Overrides Function Clone() As Object
        Dim Zhl As New Zahlung
        Zhl.Betreff = Me.Betreff
        Zhl.Datum = Me.Datum
        Zhl.Betrag = Me.Betrag
        Return Zhl
    End Function
    Public Overrides Sub ReadCloneValues(ByVal ClonedObject As Object)
        Dim Zhl As Zahlung = DirectCast(ClonedObject, Zahlung)
        Me.Betreff = Zhl.Betreff
        Me.Datum = Zhl.Datum
        Me.Betrag = Zhl.Betrag
    End Sub
#End Region

#Region " ListViewItem "
    Public Overrides Sub ListviewItem_Ausfuellen(ByVal LVI As BriefListViewItem)
        LVI.Text = Format(Me.Datum, "d")
        LVI.SubItems(1).Text = Format(m_Geldbetrag, "c")
        LVI.SubItems(2).Text = Me.Betreff
        LVI.ImageIndex = 4
    End Sub
#End Region

End Class

