Imports System.Xml
Public Class Adressliste
    Inherits SelectedObjektliste(Of Adresse)

    Private m_Arbeitsadresse As Arbeitsadresse
    Private m_Anreden As Anredeliste
    ReadOnly Property AlleAnzeigenGruppe() As BeschreibungGruppe
        Get
            Return m_AlleAnzeigenGruppe
        End Get
    End Property

    ReadOnly Property Arbeitsadresse() As Arbeitsadresse
        Get
            Return m_Arbeitsadresse
        End Get
    End Property

    ReadOnly Property AdresseNeu_Aktion() As BeschreibungAktion
        Get
            Return Me.m_AdresseNeu_Aktion
        End Get
    End Property
    ReadOnly Property AdresseLoeschen_Aktion() As BeschreibungAktion
        Get
            Return Me.m_AdresseLoeschen_Aktion
        End Get
    End Property
    ReadOnly Property AlleAnzeigen_Aktion() As BeschreibungAktion
        Get
            Return Me.m_AlleAnzeigenAktion
        End Get
    End Property
    Public Sub New(ByVal Anreden As Anredeliste)
        m_Anreden = Anreden
        Init()
    End Sub
    WriteOnly Property Anreden() As Anredeliste
        Set(ByVal value As Anredeliste)
            m_Anreden = value
            m_Arbeitsadresse = New Arbeitsadresse(Me.m_SelectedElement, m_Anreden)
        End Set
    End Property

    Public Sub New(ByVal Nd As XmlNode, ByVal Anreden As Anredeliste)
        m_Anreden = Anreden
        For Each Kn As XmlNode In Nd.ChildNodes
            If Kn.Name = "Adresse" Then
                Me.Add(New Adresse(Kn))
            End If
        Next
        Init()
    End Sub

    Private Sub Init()
        Aktionen_Initialisieren()

        If Me.Count = 0 Then
            Me.Add(New Adresse)
        End If
        SetSelectedElement(Me.Item(0), Me)
    End Sub
    Public Sub WriteXML(ByVal Writer As XmlTextWriter)
        For Each A As Adresse In Me
            Writer.WriteStartElement("Adresse")
            A.XMLSchreiben(Writer)
            Writer.WriteEndElement()
        Next
    End Sub


    Public Overrides Sub SetSelectedElement(ByVal Value As Adresse, ByVal Sender As Object)
        If m_SelectedElement IsNot Value Then
            m_SelectedElement = Value
            ArbeitsAdressAenderung()
            SelectedEventAusloesen(Value, Sender)
        End If
    End Sub
    Private Sub ArbeitsAdressAenderung()
        m_Arbeitsadresse = New Arbeitsadresse(Me.m_SelectedElement, m_Anreden)
        'Todo: nderung bei Briefanzahl-nderung
        If m_SelectedElement.Briefe.Count = 0 Then
            m_AdresseLoeschen_Aktion.VisibleState = VisibleStates.Enabled
        Else
            m_AdresseLoeschen_Aktion.VisibleState = VisibleStates.Disabled
        End If
    End Sub
    Public Overrides Sub RemoveSelected()
        If m_SelectedElement IsNot Nothing Then
            If Me.Count = 1 Then
                Me.Add(New Adresse)
            End If
            MyBase.RemoveSelected()
        End If
    End Sub
    Protected Friend Sub DuplicateSelected()
        Dim NeueAdresse As Adresse = m_SelectedElement.Clone
        AddAndSelect(NeueAdresse)
    End Sub

    Private m_MenueGruppe As BeschreibungGruppe

    Private WithEvents m_AdresseNeu_Aktion As BeschreibungAktion
    Private WithEvents m_AdresseLoeschen_Aktion As BeschreibungAktion
    Private WithEvents m_AdresseDuplizieren_Aktion As BeschreibungAktion

    Private m_AlleAnzeigenGruppe As BeschreibungGruppe

    Private m_AlleAnzeigenSeparator As BeschreibungSeparator
    Private m_AlleAnzeigenAktion As BeschreibungAktion


    Private Sub Aktionen_Initialisieren()
        Dim Helper As New ImageHelper
        m_MenueGruppe = New BeschreibungGruppe

        m_AdresseNeu_Aktion = New BeschreibungAktion("Neue Adresse", "Legt eine neue Adresse an.", VisibleStates.Enabled, Helper.CreateMergedNewImage(My.Resources.MannFrau16))
        m_AdresseLoeschen_Aktion = New BeschreibungAktion("Adresse lschen", "Lscht die ausgewhlte Adresse.", VisibleStates.Enabled, Helper.CreateMergedDeleteImage(My.Resources.MannFrau16))
        m_AdresseDuplizieren_Aktion = New BeschreibungAktion("Adresse duplizieren", "Dupliziert die ausgewhlte Adresse.")
        m_MenueGruppe.Children.Add(m_AdresseNeu_Aktion)
        m_MenueGruppe.Children.Add(m_AdresseLoeschen_Aktion)
        m_MenueGruppe.Children.Add(m_AdresseDuplizieren_Aktion)

        m_AlleAnzeigenGruppe = New BeschreibungGruppe
        m_AlleAnzeigenSeparator = New BeschreibungSeparator
        m_AlleAnzeigenAktion = New BeschreibungAktion("Alle anzeigen", "Hebt die Einschrnkung bei der Adressuche wieder auf.", VisibleStates.Enabled)
        m_AlleAnzeigenGruppe.Children.Add(m_AlleAnzeigenSeparator)
        m_AlleAnzeigenGruppe.Children.Add(m_AlleAnzeigenAktion)

        m_AlleAnzeigenGruppe.Visible = False
    End Sub

    Public Function CreateMenue() As List(Of ToolStripItem)
        Dim Liste As New List(Of ToolStripItem)
        Liste.AddRange(m_MenueGruppe.CreateElemente.ToArray)
        Liste.AddRange(m_AlleAnzeigenGruppe.CreateElemente.ToArray)
        Return Liste
    End Function

    Private Sub m_AdresseNeu_Aktion_Aktion() Handles m_AdresseNeu_Aktion.Aktion
        Dim adr As New Adresse
        Me.AddAndSelect(adr)
    End Sub

    Private Sub m_AdresseLoeschen_Aktion_Aktion() Handles m_AdresseLoeschen_Aktion.Aktion
        If MessageBox.Show("Ausgewhlte Adresse wirklich lschen?", "Briefdatenbank", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = DialogResult.No Then Exit Sub
        Me.RemoveSelected()
    End Sub

    Private Sub m_AdresseDuplizieren_Aktion_Aktion() Handles m_AdresseDuplizieren_Aktion.Aktion
        Dim adr As Adresse = m_SelectedElement.Clone
        AddAndSelect(adr)
    End Sub
End Class
