Public Class SelectedBriefInfoliste
    Inherits SelectedObjektliste(Of BriefInfo)

    Public Event Liste_Komplett_Geaendert()

    Private m_Adresse As Adresse
    Private WithEvents MySelectedBriefInfo As BriefInfo
    Private WithEvents m_Adressliste As Adressliste

    ReadOnly Property BriefNeu_Aktion() As BeschreibungAktion
        Get
            Return Me.m_BriefNeu_Aktion
        End Get
    End Property
    ReadOnly Property InfoNeu_Aktion() As BeschreibungAktion
        Get
            Return Me.m_InfoNeu_Aktion
        End Get
    End Property
    ReadOnly Property BILoesch_Aktion() As BeschreibungAktion
        Get
            Return Me.m_BILoesch_Aktion
        End Get
    End Property
    ReadOnly Property BIBearbeit_Aktion() As BeschreibungAktion
        Get
            Return Me.m_BIBearbeit_Aktion
        End Get
    End Property


    Private Sub SetAdresse(ByVal Adr As Adresse)
        m_Adresse = Adr
        Me.Clear()
        m_Adresse.Briefe.Sort(New BriefInfoComparer)
        Me.AddRange(m_Adresse.Briefe)
        Schulden_Berechnen()
        RaiseEvent Liste_Komplett_Geaendert()
        If Me.Count > 0 Then
            SetSelectedElement(Me.Item(0), Me)
        Else
            SetSelectedElement(Nothing, Me)
        End If
    End Sub
    Private Sub m_Adressliste_ElementSelectedChanged(ByVal NewSelectedElement As Adresse, ByVal Sender As Object) Handles m_Adressliste.ElementSelectedChanged
        SetAdresse(NewSelectedElement)
    End Sub
    Public Overrides Sub SetSelectedElement(ByVal Value As BriefInfo, ByVal Sender As Object)
        If m_SelectedElement IsNot Value Then
            m_SelectedElement = Value
            MySelectedBriefInfo = Value

            EditMenueAktualisieren()
            SelectedEventAusloesen(Value, Sender)
            RechnungsNummern_Verteilen()

        End If
    End Sub
    Private Sub MySelectedBriefInfo_Geaendert() Handles MySelectedBriefInfo.Geaendert
        'Fr Schulden-Berechnung
        EditMenueAktualisieren()
    End Sub

#Region " Schulden "
    Public Event Schulden_Geaendert()
    Private m_Schulden As Decimal = 0D
    ReadOnly Property Schulden() As Decimal
        Get
            Return m_Schulden
        End Get
    End Property
    Private Sub Schulden_Berechnen()
        Dim ZWert As Decimal = 0D
        For Each El As BriefInfo In Me
            If (El.Contents And BriefInfoContents.Geld) <> 0 Then
                Dim BI As IGeldelement = El
                ZWert += BI.Geldbetrag
            End If
        Next
        If m_Schulden <> ZWert Then
            m_Schulden = ZWert
            RaiseEvent Schulden_Geaendert()
        End If
    End Sub
#End Region

    Private m_Plugins As List(Of Briefdatenbank.Plugin.Common.PlugInDescription)
    Private WithEvents m_Serv As Briefdatenbank.Service.BriefBearbeitungsService
    Private m_VorlagenDirectory As String
    Private m_SpeicherDirectory As String
    Public Sub New(ByVal Adressliste As Adressliste, ByVal Plugins As List(Of Briefdatenbank.Plugin.Common.PlugInDescription), ByVal Serv As Briefdatenbank.Service.BriefBearbeitungsService, ByVal VorlagenDirectory As String, ByVal SpeicherDirectory As String)
        m_Adressliste = Adressliste
        m_Plugins = Plugins
        m_Serv = Serv
        m_VorlagenDirectory = VorlagenDirectory
        m_SpeicherDirectory = SpeicherDirectory
        MenueInitialisieren()
        EditMenueAktualisieren()
        SetAdresse(m_Adressliste.SelectedElement)
    End Sub


    Private m_NeuGruppe As BeschreibungGruppe

    Private WithEvents m_InfoNeu_Aktion As BeschreibungAktion
    Private WithEvents m_BriefNeu_Aktion As BeschreibungAktion
    'Private m_Plugin_Aktionen As List(Of BeschreibungAktion)
    Private WithEvents m_ZahlungNeu_Aktion As BeschreibungAktion

    Private m_EditProSeparator As BeschreibungSeparator

    Private m_EditGruppe As BeschreibungGruppe

    Private WithEvents m_Info_Wichtig_Aktion As BeschreibungAktion
    Private WithEvents m_RechnungErledigt_Aktion As BeschreibungAktion

    Private m_EditSeparator As BeschreibungSeparator

    Private WithEvents m_BIBearbeit_Aktion As BeschreibungAktion
    Private WithEvents m_BIEdit_Aktion As BeschreibungAktion
    Private WithEvents m_BILoesch_Aktion As BeschreibungAktion
    Private WithEvents m_BIVerschiebe_Aktion As BeschreibungAktion
    Private WithEvents m_BIExport_Aktion As BeschreibungAktion

    Private PluginItem As BeschreibungParent

    Private Sub MenueInitialisieren()
        Dim Helper As New ImageHelper

        m_NeuGruppe = New BeschreibungGruppe

        m_InfoNeu_Aktion = New BeschreibungAktion("Neue Info", "Legt einen neue Informationseintrag an.", VisibleStates.Enabled, Helper.CreateMergedNewImage(My.Resources.Info16))
        m_BriefNeu_Aktion = New BeschreibungAktion("Neuer Brief", "Legt einen neuen Brief an.", VisibleStates.Enabled, Helper.CreateMergedNewImage(My.Resources.Brief16))

        PluginItem = New BeschreibungParent("Neuer Spezialbrief", "")
        If m_Plugins.Count > 0 Then
            For Each Descr As Briefdatenbank.Plugin.Common.PlugInDescription In m_Plugins
                Dim Img As Image = Nothing
                Dim ImgBrief As Image = Helper.CreateMergedNewImage(My.Resources.Brief16)
                Dim ImgMahnung As Image = Helper.CreateMergedNewImage(My.Resources.Mahnung16)
                Dim ImgRechnung As Image = Helper.CreateMergedNewImage(My.Resources.Rechnung16)
                Select Case Descr.BriefInfoTyp
                    Case Plugin.Common.BriefInfoTypen.Brief
                        Img = ImgBrief
                    Case Plugin.Common.BriefInfoTypen.Mahnung
                        Img = ImgMahnung
                    Case Plugin.Common.BriefInfoTypen.Rechnung
                        Img = ImgRechnung
                End Select
                PluginItem.Children.Add(New BeschreibungPluginAktion(Descr.Text, Descr.Beschreibung, VisibleStates.Enabled, Img, Descr, m_Serv, m_VorlagenDirectory))
            Next
        Else
            PluginItem.VisibleState = VisibleStates.Disabled
        End If
        m_ZahlungNeu_Aktion = New BeschreibungAktion("Neue Zahlung", "Legt eine neue Zahlung an.", VisibleStates.Enabled, Helper.CreateMergedNewImage(My.Resources.Zahlungseingang16))

        m_NeuGruppe.Children.Add(m_InfoNeu_Aktion)
        m_NeuGruppe.Children.Add(m_BriefNeu_Aktion)
        m_NeuGruppe.Children.Add(PluginItem)
        m_NeuGruppe.Children.Add(m_ZahlungNeu_Aktion)

        m_EditProSeparator = New BeschreibungSeparator

        m_EditGruppe = New BeschreibungGruppe

        m_Info_Wichtig_Aktion = New BeschreibungAktion("wichtig", "Festlegen der Prioritt der ausgewhlten Information.")
        m_RechnungErledigt_Aktion = New BeschreibungAktion("bezahlt", "Trgt einen finanziellen Ausgleich fr die ausgewhlte Rechnung oder Mahnung ein.", VisibleStates.Enabled, My.Resources.Zahlungseingang16)

        m_EditSeparator = New BeschreibungSeparator

        m_BIBearbeit_Aktion = New BeschreibungAktion("", "", VisibleStates.Disabled)
        m_BIEdit_Aktion = New BeschreibungAktion("", "", VisibleStates.Disabled)
        m_BILoesch_Aktion = New BeschreibungAktion("", "", VisibleStates.Disabled)
        m_BIVerschiebe_Aktion = New BeschreibungAktion("", "", VisibleStates.Disabled)
        m_BIExport_Aktion = New BeschreibungAktion("", "", VisibleStates.Disabled)

        m_EditGruppe.Children.Add(m_Info_Wichtig_Aktion)
        m_EditGruppe.Children.Add(m_RechnungErledigt_Aktion)

        m_EditGruppe.Children.Add(m_EditSeparator)

        m_EditGruppe.Children.Add(m_BIBearbeit_Aktion)
        m_EditGruppe.Children.Add(m_BIEdit_Aktion)
        m_EditGruppe.Children.Add(m_BILoesch_Aktion)
        m_EditGruppe.Children.Add(m_BIVerschiebe_Aktion)
        m_EditGruppe.Children.Add(m_BIExport_Aktion)

        m_EditGruppe.Visible = False
    End Sub
    Private Sub EditMenueAktualisieren()
        If m_SelectedElement IsNot Nothing Then

            Dim Helper As New ImageHelper
            If m_SelectedElement.Typ = BriefInfoTypen.Info Then

                Dim Inf As Info = CType(m_SelectedElement, Info)
                m_Info_Wichtig_Aktion.Checked = Inf.Wichtig
                m_Info_Wichtig_Aktion.VisibleState = VisibleStates.Enabled
                m_RechnungErledigt_Aktion.VisibleState = VisibleStates.Invisible

                m_EditSeparator.VisibleState = VisibleStates.Enabled

                m_BIBearbeit_Aktion.SetValues("Info bearbeiten", "Inhalt der Information nachtrglich verndern.", VisibleStates.Enabled, Helper.CreateMergedDialogImage(My.Resources.Info16))
                m_BIEdit_Aktion.VisibleState = VisibleStates.Invisible
                m_BILoesch_Aktion.SetValues("Info lschen", "Entfernt die ausgewhlte Information.", VisibleStates.Enabled, Helper.CreateMergedDeleteImage(My.Resources.Info16))
                m_BIVerschiebe_Aktion.SetValues("Info verschieben", "Ordnet die Information einer anderen Adresse zu.", VisibleStates.Enabled, Helper.CreateMergedMoveImage(My.Resources.Info16))
                m_BIExport_Aktion.VisibleState = VisibleStates.Invisible

            ElseIf m_SelectedElement.Typ = BriefInfoTypen.Zahlung Then
                m_Info_Wichtig_Aktion.VisibleState = VisibleStates.Invisible
                m_RechnungErledigt_Aktion.VisibleState = VisibleStates.Invisible

                m_EditSeparator.VisibleState = VisibleStates.Invisible

                m_BIBearbeit_Aktion.SetValues("Zahlung bearbeiten", "Inhalt der Zahlung nachtrglich verndern.", VisibleStates.Enabled, Helper.CreateMergedDialogImage(My.Resources.Zahlungseingang16))
                m_BIEdit_Aktion.VisibleState = VisibleStates.Invisible
                m_BILoesch_Aktion.SetValues("Zahlung lschen", "Entfernt die ausgewhlte Zahlung.", VisibleStates.Enabled, Helper.CreateMergedDeleteImage(My.Resources.Zahlungseingang16))
                m_BIVerschiebe_Aktion.SetValues("Zahlung verschieben", "Ordnet die Zahlung einer anderen Adresse zu.", VisibleStates.Enabled, Helper.CreateMergedMoveImage(My.Resources.Zahlungseingang16))
                m_BIExport_Aktion.VisibleState = VisibleStates.Invisible

            ElseIf m_SelectedElement.Typ = BriefInfoTypen.Rechnung Then
                m_Info_Wichtig_Aktion.VisibleState = VisibleStates.Invisible

                m_RechnungErledigt_Aktion.Image = Helper.CreateMergedErledigtImage(My.Resources.Rechnung16)
                m_RechnungErledigt_Aktion.Beschreibung = "Trgt einen finanziellen Ausgleich fr die ausgewhlte Rechnung ein."
                m_RechnungErledigt_Aktion.VisibleState = VisibleStates.Enabled

                m_EditSeparator.VisibleState = VisibleStates.Enabled

                m_BIBearbeit_Aktion.SetValues("Rechnung bearbeiten", "ffnet die Rechnung in Microsoft Word.", VisibleStates.Enabled, Helper.CreateMergedWordImage(My.Resources.Rechnung16))
                m_BIEdit_Aktion.SetValues("Rechnung Daten editieren", "ffnet ein Dialogfeld, um Details der Rechnung nachtrglich zu verndern.", VisibleStates.Enabled, Helper.CreateMergedDialogImage(My.Resources.Rechnung16))
                m_BILoesch_Aktion.SetValues("Rechnung lschen", "Entfernt die ausgewhlte Rechnung.", VisibleStates.Enabled, Helper.CreateMergedDeleteImage(My.Resources.Rechnung16))
                m_BIVerschiebe_Aktion.SetValues("Rechnung verschieben", "Ordnet die ausgewhlte Rechnung einer anderen Adresse zu.", VisibleStates.Enabled, Helper.CreateMergedMoveImage(My.Resources.Rechnung16))
                m_BIExport_Aktion.SetValues("Rechnung exportieren", "Kopiert diese Rechnung an einen anderen Platz auf diesem Computer oder einen Datentrger.", VisibleStates.Enabled, Helper.CreateMergedExportImage(My.Resources.Rechnung16))

            ElseIf m_SelectedElement.Typ = BriefInfoTypen.Mahnung Then
                m_Info_Wichtig_Aktion.VisibleState = VisibleStates.Invisible

                m_RechnungErledigt_Aktion.Image = Helper.CreateMergedErledigtImage(My.Resources.Mahnung16)
                m_RechnungErledigt_Aktion.Beschreibung = "Trgt einen finanziellen Ausgleich fr die ausgewhlte Mahnung ein."
                m_RechnungErledigt_Aktion.VisibleState = VisibleStates.Enabled

                m_EditSeparator.VisibleState = VisibleStates.Enabled

                m_BIBearbeit_Aktion.SetValues("Mahnung bearbeiten", "ffnet die Mahnung in Microsoft Word.", VisibleStates.Enabled, Helper.CreateMergedWordImage(My.Resources.Mahnung16))
                m_BIEdit_Aktion.SetValues("Mahnung Daten editieren", "ffnet ein Dialogfeld, um Details der Mahnung nachtrglich zu verndern.", VisibleStates.Enabled, Helper.CreateMergedDialogImage(My.Resources.Mahnung16))
                m_BILoesch_Aktion.SetValues("Mahnung lschen", "Entfernt die ausgewhlte Mahnung.", VisibleStates.Enabled, Helper.CreateMergedDeleteImage(My.Resources.Mahnung16))
                m_BIVerschiebe_Aktion.SetValues("Mahnung verschieben", "Ordnet die ausgewhlte Mahnung einer anderen Adresse zu.", VisibleStates.Enabled, Helper.CreateMergedMoveImage(My.Resources.Mahnung16))
                m_BIExport_Aktion.SetValues("Mahnung exportieren", "Kopiert diese Mahnung an einen anderen Platz auf diesem Computer oder einen Datentrger.", VisibleStates.Enabled, Helper.CreateMergedExportImage(My.Resources.Mahnung16))

            ElseIf m_SelectedElement.Typ = BriefInfoTypen.Brief Then
                m_Info_Wichtig_Aktion.VisibleState = VisibleStates.Invisible
                m_RechnungErledigt_Aktion.VisibleState = VisibleStates.Invisible
                m_EditSeparator.VisibleState = VisibleStates.Invisible

                m_BIBearbeit_Aktion.SetValues("Brief bearbeiten", "ffnet den Brief in Microsoft Word.", VisibleStates.Enabled, Helper.CreateMergedWordImage(My.Resources.Brief16))
                m_BIEdit_Aktion.SetValues("Brief Daten editieren", "ffnet ein Dialogfeld, um Details des Briefes nachtrglich zu verndern.", VisibleStates.Enabled, Helper.CreateMergedDialogImage(My.Resources.Brief16))
                m_BILoesch_Aktion.SetValues("Brief lschen", "Entfernt den ausgewhlten Brief.", VisibleStates.Enabled, Helper.CreateMergedDeleteImage(My.Resources.Brief16))
                m_BIVerschiebe_Aktion.SetValues("Brief verschieben", "Ordnet den ausgewhlten Brief einer anderen Adresse zu.", VisibleStates.Enabled, Helper.CreateMergedMoveImage(My.Resources.Brief16))
                m_BIExport_Aktion.SetValues("Brief exportieren", "Kopiert diesen Brief an einen anderen Platz auf diesem Computer oder einen Datentrger.", VisibleStates.Enabled, Helper.CreateMergedExportImage(My.Resources.Brief16))

            End If
            m_EditProSeparator.Visible = True
            m_EditGruppe.Visible = True
        Else
            m_EditProSeparator.Visible = False
            m_EditGruppe.Visible = False
        End If

    End Sub

    Public Function CreateMenue() As List(Of ToolStripItem)
        Dim Liste As New List(Of ToolStripItem)
        Liste.AddRange(m_NeuGruppe.CreateElemente.ToArray)
        Liste.AddRange(m_EditProSeparator.CreateElemente.ToArray)
        Liste.AddRange(m_EditGruppe.CreateElemente.ToArray)
        Return Liste
    End Function

    Private Sub AddNewAndSort(ByVal NewElement As BriefInfo)
        Me.Add(NewElement)
        m_Adresse.Briefe.Add(NewElement)

        m_SelectedElement = NewElement
        MySelectedBriefInfo = NewElement
        EditMenueAktualisieren()
        Me.Sort(New BriefInfoComparer)

        RechnungsNummern_Verteilen()
        RaiseEvent Liste_Komplett_Geaendert()
    End Sub

    Private Sub m_BriefNeu_Aktion_Aktion() Handles m_BriefNeu_Aktion.Aktion
        Dim Brf As New Brief
        Dim Frm As New frm_InfoBearbeiten(True, Brf)
        If Frm.ShowDialog = Windows.Forms.DialogResult.OK Then
            Dim WF As New WordFunktionen

            If Not IO.File.Exists(m_VorlagenDirectory & "\" & m_Adresse.Dokumentenvorlage & ".dot") Then
                If WF.Dok_VorlageErstellen(m_Adresse.Dokumentenvorlage, m_VorlagenDirectory) = False Then
                    Exit Sub
                End If
            End If

            Brf.Pfad = WF.DateinameSonderzeichenErsetzen(m_Adresse.Kuerzel_Erstellen & " " & Brf.Datum.ToShortDateString & ", " & Format(Brf.Datum, "HH.mm.ss"))
            If WF.Word_Brief_Erstellen(m_Adressliste.Arbeitsadresse, Brf, m_SpeicherDirectory, m_VorlagenDirectory) Then
                AddNewAndSort(Brf)
            End If
        End If
    End Sub

    Private Sub m_InfoNeu_Aktion_Aktion() Handles m_InfoNeu_Aktion.Aktion
        Dim Inf As New Info
        Dim Frm As New frm_InfoBearbeiten(True, Inf)
        If Frm.ShowDialog = Windows.Forms.DialogResult.OK Then
            AddNewAndSort(Inf)
        End If
    End Sub

    'Dieses Event wird geliefert, wenn eine Plugin-Aktion abgeschlossen wurde
    Private Sub m_Serv_Arbeit_Ausgefuehrt(ByVal Descr As Plugin.Common.PlugInDescription, ByVal Res As Plugin.Common.PlugInResult) Handles m_Serv.Arbeit_Ausgefuehrt
        If Res.PersistText <> "" Then

            Dim Dateiname As String = PluginBriefSchreiben_Dateiname_Liefern(Descr, Res)
            If Dateiname = "" Then Exit Sub

            Dim NeuItem As Brief = Nothing
            Select Case Descr.BriefInfoTyp
                Case Plugin.Common.BriefInfoTypen.Rechnung
                    NeuItem = New Rechnung
                Case Plugin.Common.BriefInfoTypen.Mahnung
                    NeuItem = New Mahnung
                Case Plugin.Common.BriefInfoTypen.Brief
                    NeuItem = New Brief
            End Select
            NeuItem.Pfad = Dateiname
            NeuItem.Betreff = Res.BetreffText
            NeuItem.Datum = Res.Datum
            If (NeuItem.Contents And BriefInfoContents.Geld) <> 0 Then
                'Das gibts nur bei Rechnung und Mahnung
                Dim Re As Rechnung = CType(NeuItem, Rechnung)
                Re.Betrag = Res.Geldbetrag
                Re.Rechnungsnummer = Res.RechnungsNummer
            End If

            AddNewAndSort(NeuItem)

            If (NeuItem.Contents And BriefInfoContents.Geld) <> 0 Then
                Me.Schulden_Berechnen()
            End If

        End If
    End Sub
    Private Function PluginBriefSchreiben_Dateiname_Liefern(ByVal Descr As Plugin.Common.PlugInDescription, ByVal Res As Plugin.Common.PlugInResult) As String

        Res.PersistText = Descr.PluginID.ToString & Res.PersistText

        Res.Datum = Res.Datum.AddHours(DateTime.Now.Hour)
        Res.Datum = Res.Datum.AddMinutes(DateTime.Now.Minute)
        Res.Datum = Res.Datum.AddSeconds(DateTime.Now.Second)

        Dim WF As New WordFunktionen
        If Not IO.File.Exists(m_VorlagenDirectory & "\" & m_Adresse.Dokumentenvorlage & ".dot") Then
            If WF.Dok_VorlageErstellen(m_Adresse.Dokumentenvorlage, m_VorlagenDirectory) = False Then
                Return ""
            End If
        End If

        Dim BriefDateiname As String = WF.DateinameSonderzeichenErsetzen(m_Adresse.Kuerzel_Erstellen & " " & Res.Datum.ToShortDateString & ", " & Format(Res.Datum, "HH.mm.ss"))
        Dim DokumentPfad As String = m_SpeicherDirectory & "\" & BriefDateiname & ".doc"

        If WF.Word_Plugin_Brief_Erstellen(m_Adressliste.Arbeitsadresse, DokumentPfad, m_VorlagenDirectory, Res) Then
            Return BriefDateiname
        Else
            Return ""
        End If

    End Function

    Private Sub m_ZahlungNeu_Aktion_Aktion() Handles m_ZahlungNeu_Aktion.Aktion
        Dim Zhl As New Zahlung
        Dim Frm As New frm_InfoBearbeiten(True, Zhl)
        If Frm.ShowDialog = Windows.Forms.DialogResult.OK Then
            AddNewAndSort(Zhl)
            Me.Schulden_Berechnen()
        End If
    End Sub


    Private Sub m_BIBearbeit_Aktion_Aktion() Handles m_BIBearbeit_Aktion.Aktion
        If m_SelectedElement IsNot Nothing Then

            Select Case m_SelectedElement.Typ
                Case BriefInfoTypen.Info, BriefInfoTypen.Zahlung
                    Dim Cln As BriefInfo = m_SelectedElement.Clone
                    Dim frm As New frm_InfoBearbeiten(False, Cln)
                    If frm.ShowDialog() = DialogResult.OK Then
                        m_SelectedElement.ReadCloneValues(Cln)
                        If (m_SelectedElement.Contents And BriefInfoContents.Geld) <> 0 Then
                            Me.Schulden_Berechnen()
                        End If
                        Me.Sort(New BriefInfoComparer)
                        RaiseEvent Liste_Komplett_Geaendert()
                    End If
                Case Else
                    Dim Brf As Brief = CType(m_SelectedElement, Brief)
                    Dim WF As New WordFunktionen
                    WF.Word_Dokument_Oeffnen(m_SpeicherDirectory & "\" & Brf.Pfad & ".doc")
            End Select
        End If
    End Sub


    Private Sub m_BIEdit_Aktion_Aktion() Handles m_BIEdit_Aktion.Aktion
        'Dies gibts nur bei Brief, Rechnung, Mahnung 
        Dim OldBriefPfad As String = ""
        Dim AltRechngNr As String = ""

        Select Case m_SelectedElement.Typ
            Case BriefInfoTypen.Info, BriefInfoTypen.Zahlung
                Exit Sub
            Case BriefInfoTypen.Brief
                Dim Brf As Brief = CType(m_SelectedElement, Brief)
                OldBriefPfad = m_SpeicherDirectory & "\" & Brf.Pfad & ".doc"
            Case Else
                Dim Rchng As Rechnung = CType(m_SelectedElement, Rechnung)
                OldBriefPfad = m_SpeicherDirectory & "\" & Rchng.Pfad & ".doc"
                AltRechngNr = Rchng.Rechnungsnummer
        End Select


        If Not IO.File.Exists(OldBriefPfad) Then
            MessageBox.Show("Das ausgewhlte Schreiben wurde offenbar zwischenzeitlich gelscht.")
            Exit Sub
        End If

        Dim ReeditText As String = ""
        Dim PluginNr As Integer = 0
        Dim SDescr As Briefdatenbank.Plugin.Common.PlugInDescription = Nothing

        Dim WF As New WordFunktionen
        ReeditText = WF.ReadProperties(OldBriefPfad)
        If ReeditText <> "" Then
            Dim NummernAbschnitt As String = ReeditText.Substring(0, ReeditText.IndexOf("<"))
            ReeditText = ReeditText.Substring(ReeditText.IndexOf("<"))
            Try
                PluginNr = CInt(NummernAbschnitt)
            Catch ex As Exception

            End Try
            If PluginNr <> 0 Then
                For Each Descr As Briefdatenbank.Plugin.Common.PlugInDescription In m_Plugins
                    If Descr.PluginID = PluginNr Then
                        SDescr = Descr
                        Exit For
                    End If
                Next
            End If
        End If


        If SDescr Is Nothing Then
            Dim ClonedObject As Object = m_SelectedElement.Clone
            Dim frm As New frm_InfoBearbeiten(False, ClonedObject)
            If frm.ShowDialog = DialogResult.OK Then
                m_SelectedElement.ReadCloneValues(ClonedObject)
                If (m_SelectedElement.Contents And BriefInfoContents.Geld) <> 0 Then
                    Me.Schulden_Berechnen()
                End If
                Me.Sort(New BriefInfoComparer)
                RaiseEvent Liste_Komplett_Geaendert()
            End If
        Else

            Dim UeDaten As New Briefdatenbank.Plugin.Common.PlugInUebergabeDaten(AltRechngNr, m_VorlagenDirectory, ReeditText)
            Dim Result As Briefdatenbank.Plugin.Common.PlugInResult = m_Serv.ReEdit(SDescr, UeDaten)
            If Result.Liste_Texte.Count > 0 Then
                Dim NeuDateiname As String = PluginBriefSchreiben_Dateiname_Liefern(SDescr, Result)
                If NeuDateiname <> "" Then
                    Try
                        IO.File.Delete(OldBriefPfad)
                    Catch ex As Exception

                    End Try
                    Dim ObjectToRemove As BriefInfo = m_SelectedElement

                    Dim NeuItem As Brief = Nothing
                    Select Case SDescr.BriefInfoTyp
                        Case Plugin.Common.BriefInfoTypen.Rechnung
                            NeuItem = New Rechnung
                        Case Plugin.Common.BriefInfoTypen.Mahnung
                            NeuItem = New Mahnung
                        Case Plugin.Common.BriefInfoTypen.Brief
                            NeuItem = New Brief
                    End Select
                    NeuItem.Pfad = NeuDateiname
                    NeuItem.Betreff = Result.BetreffText
                    NeuItem.Datum = Result.Datum


                    If (NeuItem.Contents And BriefInfoContents.Geld) <> 0 Then
                        'Das gibts nur bei Rechnung und Mahnung
                        Dim Re As Rechnung = CType(NeuItem, Rechnung)
                        Re.Betrag = Result.Geldbetrag
                        Re.Rechnungsnummer = Result.RechnungsNummer
                    End If

                    m_Adresse.Briefe.Remove(ObjectToRemove)
                    Me.Remove(ObjectToRemove)

                    AddNewAndSort(NeuItem)


                    If (NeuItem.Contents And BriefInfoContents.Geld) <> 0 Then
                        Me.Schulden_Berechnen()
                    End If

                End If
            End If
        End If

    End Sub

    Private Sub m_BIExport_Aktion_Aktion() Handles m_BIExport_Aktion.Aktion
        'Dies gibts nur bei Brief, Rechnung, Mahnung 

        Dim Brf As Brief = m_SelectedElement
        Dim AlterPfad As String = m_SpeicherDirectory & "\" & Brf.Pfad
        If Not IO.File.Exists(AlterPfad) Then
            MessageBox.Show("Die ausgewhlte Datei existiert am angegebenen Pfad nicht mehr.")
            Exit Sub
        End If


        Dim Dlg As New SaveFileDialog

        Dlg.FileName = Brf.Pfad
        Dlg.Filter = "Word-Dokumente (*.doc)|*.doc"
        Dlg.FilterIndex = 0
        Dlg.AddExtension = True
        Dlg.OverwritePrompt = True
        Dlg.RestoreDirectory = True
        Dlg.Title = m_BIExport_Aktion.Text

        If Dlg.ShowDialog() = DialogResult.OK Then
            IO.File.Copy(AlterPfad, Dlg.FileName, True)
        End If

    End Sub

    Private Sub m_BILoesch_Aktion_Aktion() Handles m_BILoesch_Aktion.Aktion
        Dim IstBrief As Boolean = False
        Dim IstGeldElement As Boolean = False

        Dim Titel As String = "Wollen Sie "
        Select Case m_SelectedElement.Typ
            Case BriefInfoTypen.Brief
                Titel &= "den ausgewhlten Brief"
                IstBrief = True
            Case BriefInfoTypen.Mahnung
                Titel &= "die ausgewhlte Mahnung"
                IstBrief = True
                IstGeldElement = True
            Case BriefInfoTypen.Rechnung
                Titel &= "die ausgewhlte Rechnung"
                IstBrief = True
                IstGeldElement = True
            Case BriefInfoTypen.Info
                Titel &= "die ausgewhlte Info"
            Case BriefInfoTypen.Zahlung
                Titel &= "die ausgewhlte Zahlung"
                IstGeldElement = True
        End Select

        Titel &= " wirklich lschen?"

        If MessageBox.Show(Titel, "Briefdatenbank", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button2) = DialogResult.No Then
            Exit Sub
        End If


        'Bei Brief, Rechnung, Mahnung muss die Datei gelscht werden knnen
        If IstBrief Then
            Dim LoeschHindernis As Boolean = False
            Dim Brf As Brief = m_SelectedElement
            If IO.File.Exists(m_SpeicherDirectory & "\" & Brf.Pfad) Then
                Try
                    IO.File.Delete(m_SpeicherDirectory & "\" & Brf.Pfad)
                Catch ex As Exception
                    MessageBox.Show("Fehler beim Lschen eines Briefdatenbank-Dokuments:" & vbCrLf & ex.Message, "Briefdatenbank", MessageBoxButtons.OK, MessageBoxIcon.Information)
                    LoeschHindernis = True
                End Try
            End If
            If LoeschHindernis Then
                Exit Sub
            End If
        End If

        m_Adresse.Briefe.Remove(m_SelectedElement)
        Me.RemoveSelected()
        If IstGeldElement Then
            Schulden_Berechnen()
        End If
       
    End Sub

    Private Sub m_BIVerschiebe_Aktion_Aktion() Handles m_BIVerschiebe_Aktion.Aktion
  

        Dim frm As New frm_BriefVerschieben
        frm.Text = m_BIVerschiebe_Aktion.Text
        frm.Icon = My.Resources.bdb2

        Dim NeueAdressliste As New AdresslisteEinfach
        NeueAdressliste.AddRange(m_Adressliste.ToArray)
        NeueAdressliste.SetSelectedElement(NeueAdressliste.Item(0), Me)
        frm.Adessauswaehler1.Adressliste = NeueAdressliste
        If frm.ShowDialog() = DialogResult.OK Then
            Dim ZielAdresse As Adresse = NeueAdressliste.SelectedElement
            If Not ZielAdresse Is m_Adresse Then
                Dim BI As BriefInfo = m_SelectedElement

                m_Adresse.Briefe.Remove(m_SelectedElement)
                Me.RemoveSelected()
                ZielAdresse.Briefe.Add(BI)
                If (BI.Contents And BriefInfoContents.Geld) Then
                    Me.Schulden_Berechnen()
                End If
            End If
        End If
        
    End Sub

    Private Sub m_Info_Wichtig_Aktion_Aktion() Handles m_Info_Wichtig_Aktion.Aktion
        Dim Inf As Info = m_SelectedElement
        Inf.Wichtig = Not Inf.Wichtig
        Me.Sort(New BriefInfoComparer)
        RaiseEvent Liste_Komplett_Geaendert()
    End Sub

    Private Function FreieRechnungsNumer_Finden() As String
        'Eine freie Rechnungsnummer muss gesucht werden:
        'beim Anlegen einer Rechnung
        'ggf. beim Anlegen einer Mahnung
        'Ist beim Anlegen einer Mahnung eine Rechnung oder Mahnung selektiert, wird deren Rechnungsnummer 
        'verwendet

        'Diese Funktion wird nur verwendet, wenn sich m_SelectedBriefInfo gendert hat,
        'dann wird allen Plugin-Aktionen eine entsprechende Rechnungsnummer zugeordnet

        Dim Jahrtext As String = "/" & DateTime.Today.Year.ToString.Substring(2)

        Dim Gefundene As New List(Of String)

        For Each adr As Adresse In m_Adressliste
            For Each Inf As BriefInfo In adr.Briefe
                If (Inf.Typ = BriefInfoTypen.Rechnung) Or (Inf.Typ = BriefInfoTypen.Mahnung) Then
                    Dim Re As Rechnung = Inf
                    If Re.Rechnungsnummer.EndsWith(Jahrtext) Then
                        Gefundene.Add(Re.Rechnungsnummer.Substring(0, Re.Rechnungsnummer.Length - 3))
                    End If
                End If
            Next
        Next

        Dim I As Integer = 0
        While True
            I += 1
            If Not Gefundene.Contains(I.ToString) Then
                Return I.ToString & Jahrtext
            End If
        End While
        Return Nothing
    End Function
    Private Sub RechnungsNummern_Verteilen()
        Dim NeueRechnungsNummer As String = FreieRechnungsNumer_Finden()
        Dim AktiveRechnungsNummer As String = ""
        If m_SelectedElement IsNot Nothing Then
            If m_SelectedElement.Typ = BriefInfoTypen.Rechnung Or m_SelectedElement.Typ = BriefInfoTypen.Mahnung Then
                Dim Inf As Rechnung = m_SelectedElement
                AktiveRechnungsNummer = Inf.Rechnungsnummer
            End If
        End If

        For Each Akt As BeschreibungPluginAktion In PluginItem.Children
            If Akt.Typ = Plugin.Common.BriefInfoTypen.Mahnung Then
                If AktiveRechnungsNummer <> "" Then
                    Akt.RechnungsNr = AktiveRechnungsNummer
                Else
                    Akt.RechnungsNr = NeueRechnungsNummer
                End If
            ElseIf Akt.Typ = Plugin.Common.BriefInfoTypen.Rechnung Then
                Akt.RechnungsNr = NeueRechnungsNummer
            End If
        Next

    End Sub

    Private Sub m_RechnungErledigt_Aktion_Aktion() Handles m_RechnungErledigt_Aktion.Aktion
        Dim ZA As New Zahlung
        ZA.Betreff = "Zahlung fr " & m_SelectedElement.Betreff
        Dim Re As Rechnung = m_SelectedElement
        ZA.Betrag = Re.Betrag * -1D
        ZA.Datum = Date.Now
        AddNewAndSort(ZA)
        Me.Schulden_Berechnen()

    End Sub
End Class
