Public Class ObjektListBox
    Private Initialisierung As Boolean = False
    Private SelectionStopp As Boolean = False
    Private EventStopp As Boolean = False

    Public Event AuswahlGeaendert(ByVal oAuswahl As Object)
    Public Event AktionsAnfrage(ByVal Akt As ObjektListBoxAktion)


    Property TextBoxVisible() As Boolean
        Get
            Return Me.PanelTextBox.Visible
        End Get
        Set(ByVal Value As Boolean)
            Me.PanelTextBox.Visible = Value
        End Set
    End Property
    Property LabelText() As String
        Get
            Return Me.ColorLabelTitel.LabelText
        End Get
        Set(ByVal Value As String)
            Me.ColorLabelTitel.LabelText = Value
        End Set
    End Property


    Public Sub Initialisieren(ByVal Liste As IList)
        Me.ListBoxWerte.Items.Clear()
        Me.ButtonLoeschen.Enabled = False
        Me.ButtonNO.Enabled = False
        Me.ButtonNU.Enabled = False
        If IsNothing(Liste) Then
            Me.ButtonNeu.Enabled = False
        Else
            For Each O As Object In Liste
                Me.ListBoxWerte.Items.Add(O)
            Next
            If ListBoxWerte.Items.Count > 0 Then
                ListBoxWerte.SelectedIndex = 0
                Initialisierung = True
                Me.TextBoxInhalt.Text = ListBoxWerte.SelectedItem.ToString
                Me.TextBoxInhalt.Enabled = True
                Initialisierung = False
            End If
            Me.ButtonNeu.Enabled = True
        End If

    End Sub

    Private Sub ListBoxWerte_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListBoxWerte.DoubleClick
        If IsNothing(ListBoxWerte.SelectedItem) Then Exit Sub
        Dim Oakt As New ObjektListBoxAktion(ListBoxWerte.SelectedIndex, Me.ListBoxWerte.SelectedItem, ObjektListBoxAktionen.ObjektInputBoxAnzeigen, False)
        RaiseEvent AktionsAnfrage(Oakt)
        If Oakt.Erlaubt Then
            SelectionStopp = True
            Dim Selindex As Integer = ListBoxWerte.SelectedIndex
            ListBoxWerte.Items.RemoveAt(Selindex)
            ListBoxWerte.Items.Insert(Selindex, Oakt.Obj)
            ListBoxWerte.SelectedIndex = Selindex
            SelectionStopp = False
        End If
    End Sub

    Private Sub ListBoxWerte_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListBoxWerte.SelectedIndexChanged
        If SelectionStopp Then Exit Sub
        If PanelTextBox.Visible Then
            Initialisierung = True
            If ListBoxWerte.SelectedIndex = -1 Then
                Me.TextBoxInhalt.Text = ""
                Me.TextBoxInhalt.Enabled = False
            Else
                Me.TextBoxInhalt.Text = ListBoxWerte.SelectedItem.ToString
                Me.TextBoxInhalt.Enabled = True
            End If
            Initialisierung = False
        End If
        ButtonsUeberpruefen()
        If Not EventStopp Then
            RaiseEvent AuswahlGeaendert(ListBoxWerte.SelectedItem)
        End If
    End Sub
    Private Sub ButtonsUeberpruefen()
        If ListBoxWerte.SelectedIndex = -1 Then
            Me.ButtonLoeschen.Enabled = False
            Me.ButtonNO.Enabled = False
            Me.ButtonNU.Enabled = False
        Else
            Me.ButtonLoeschen.Enabled = True
            If ListBoxWerte.SelectedIndex = 0 Then
                Me.ButtonNO.Enabled = False
            Else
                Me.ButtonNO.Enabled = True
            End If
            If ListBoxWerte.SelectedIndex = ListBoxWerte.Items.Count - 1 Then
                Me.ButtonNU.Enabled = False
            Else
                Me.ButtonNU.Enabled = True
            End If
        End If
    End Sub


    Private Sub ObjektListBox_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        If Me.Width < 180 Then
            Me.ButtonNO.Visible = False
            Me.ButtonNU.Visible = False
        Else
            Me.ButtonNO.Visible = True
            Me.ButtonNU.Visible = True
        End If
    End Sub


    Private Sub ButtonNeu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonNeu.Click
        Dim Oakt As New ObjektListBoxAktion(0, Nothing, ObjektListBoxAktionen.ObjektNeu, False)
        RaiseEvent AktionsAnfrage(Oakt)
        If Oakt.Erlaubt Then
            Me.ListBoxWerte.Items.Add(Oakt.Obj)
            Me.ListBoxWerte.SelectedIndex = ListBoxWerte.Items.Count - 1
        End If
    End Sub

    Private Sub ButtonLoeschen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonLoeschen.Click
        Dim Oakt As New ObjektListBoxAktion(ListBoxWerte.SelectedIndex, Me.ListBoxWerte.SelectedItem, ObjektListBoxAktionen.ObjektLschen, False)
        RaiseEvent AktionsAnfrage(Oakt)
        If Oakt.Erlaubt Then
            Me.ListBoxWerte.Items.RemoveAt(Oakt.SelIndex)
            If ListBoxWerte.Items.Count > Oakt.SelIndex Then
                ListBoxWerte.SelectedIndex = Oakt.SelIndex
            Else
                ListBoxWerte.SelectedIndex = Oakt.SelIndex - 1
            End If
        End If
    End Sub

    Private Sub ButtonNO_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonNO.Click
        Dim Oakt As New ObjektListBoxAktion(ListBoxWerte.SelectedIndex, Me.ListBoxWerte.SelectedItem, ObjektListBoxAktionen.ObjektNOVerschieben, False)
        RaiseEvent AktionsAnfrage(Oakt)
        If Oakt.Erlaubt Then
            Dim BewObj As Object = ListBoxWerte.Items(Oakt.SelIndex - 1)
            EventStopp = True
            ListBoxWerte.Items.Remove(BewObj)
            ListBoxWerte.Items.Insert(Oakt.SelIndex, BewObj)
            EventStopp = False
            ButtonsUeberpruefen()
        End If
    End Sub

    Private Sub ButtonNU_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonNU.Click
        Dim Oakt As New ObjektListBoxAktion(ListBoxWerte.SelectedIndex, Me.ListBoxWerte.SelectedItem, ObjektListBoxAktionen.ObjektNUVerschieben, False)
        RaiseEvent AktionsAnfrage(Oakt)
        If Oakt.Erlaubt Then
            Dim BewObj As Object = ListBoxWerte.Items(Oakt.SelIndex + 1)
            EventStopp = True
            ListBoxWerte.Items.RemoveAt(Oakt.SelIndex + 1)
            ListBoxWerte.Items.Insert(Oakt.SelIndex, BewObj)
            EventStopp = False
            ButtonsUeberpruefen()
        End If
    End Sub

    Private Sub TextBoxInhalt_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBoxInhalt.TextChanged
        If Initialisierung Then Exit Sub
        If IsNothing(ListBoxWerte.SelectedItem) Then Exit Sub
        If TextBoxInhalt.Text.Trim = "" Then Exit Sub
        Dim Oakt As New ObjektListBoxAktion(ListBoxWerte.SelectedIndex, Me.ListBoxWerte.SelectedItem, ObjektListBoxAktionen.ObjektUmbenennen, False)
        Oakt.Text = TextBoxInhalt.Text
        RaiseEvent AktionsAnfrage(Oakt)
        If Oakt.Erlaubt Then
            SelectionStopp = True
            ListBoxWerte.Items.RemoveAt(Oakt.SelIndex)
            ListBoxWerte.Items.Insert(Oakt.SelIndex, Oakt.Obj)
            ListBoxWerte.SelectedIndex = Oakt.SelIndex
            SelectionStopp = False
        End If
    End Sub

    Public Sub TextRefresh()
        SelectionStopp = True
        Dim Selindex As Integer = ListBoxWerte.SelectedIndex
        Dim Merkobj As Object = ListBoxWerte.SelectedItem
        ListBoxWerte.Items.RemoveAt(Selindex)
        ListBoxWerte.Items.Insert(Selindex, Merkobj)
        ListBoxWerte.SelectedIndex = Selindex
        SelectionStopp = False
    End Sub
End Class
