Imports System.ComponentModel
Public Class frm_DocSucher

    Public Ergebnisse As List(Of String)


    Public Sub New(ByVal StartPfad As String)

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        Ergebnisse = New List(Of String)
        BackgroundWorker1.RunWorkerAsync(StartPfad)

    End Sub

    Function Dokumente_Suchen(ByVal StartPfad As String, ByVal worker As BackgroundWorker, ByVal e As DoWorkEventArgs, ByVal Status As DocSucherState) As List(Of String)
        Dim Liste As New List(Of String)

        If worker.CancellationPending Then
            e.Cancel = True
        Else
            Dim Dateien() As String = IO.Directory.GetFiles(StartPfad, "*.doc")

            Liste.AddRange(Dateien)
            Dim Dirs() As String = IO.Directory.GetDirectories(StartPfad)

            Status.DokumenteGefunden += Dateien.Length
            Status.Verzeichnisse += Dirs.Length

            For Each txt As String In Dirs
                Dim NeueListe As List(Of String) = Dokumente_Suchen(txt, worker, e, Status)
                Liste.AddRange(NeueListe)
                Status.VerzeichnisseDurchsucht += 1
            Next

            'Dim percentComplete As Integer = CSng(Status.VerzeichnisseDurchsucht) / CSng(Status.Verzeichnisse) * 100

            If Status.Verzeichnisse = Status.VerzeichnisseDurchsucht Then
                worker.ReportProgress(100, Status)
            Else
                worker.ReportProgress(10, Status)
            End If

        End If


        Return Liste
    End Function

    Private Sub BackgroundWorker1_DoWork(ByVal sender As Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles BackgroundWorker1.DoWork
        Dim worker As BackgroundWorker = CType(sender, BackgroundWorker)
        'worker.ReportProgress 
        Dim Status As New DocSucherState(0, 0, 0)

        e.Result = Dokumente_Suchen(e.Argument, worker, e, Status)
    End Sub

    Private Sub BackgroundWorker1_ProgressChanged(ByVal sender As Object, ByVal e As System.ComponentModel.ProgressChangedEventArgs) Handles BackgroundWorker1.ProgressChanged
        Dim State As DocSucherState = e.UserState
        Me.LabelNeueDokumente.Text = "Insgesamt " & State.DokumenteGefunden.ToString & " neue Word-Dokumente."
        Me.LabelOrdnerDurchsucht.Text = "davon " & State.VerzeichnisseDurchsucht.ToString & " Verzeichnisse vollstndig durchsucht."
        Me.LabelOrdnerGefunden.Text = "Bisher " & State.Verzeichnisse.ToString & " neue Verzeichnisse gefunden,"

    End Sub

    Private Sub BackgroundWorker1_RunWorkerCompleted(ByVal sender As Object, ByVal e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles BackgroundWorker1.RunWorkerCompleted
        If (e.Error IsNot Nothing) Then
            MessageBox.Show(e.Error.Message)
        ElseIf e.Cancelled Then
            Me.DialogResult = Windows.Forms.DialogResult.Cancel
            Me.Close()
            'resultLabel.Text = "Canceled"
        Else
            ' Finally, handle the case where the operation succeeded.
            Dim Res As List(Of String) = e.Result
            For Each Txt As String In Res
                Ergebnisse.Add(Txt)
            Next
            Me.DialogResult = Windows.Forms.DialogResult.OK
            Me.Close()
            'resultLabel.Text = e.Result.ToString()
        End If

        'ButtonAbbrechen.Enabled = False
    End Sub

    Private Sub ButtonAbbrechen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonAbbrechen.Click
        Me.BackgroundWorker1.CancelAsync()
        ButtonAbbrechen.Enabled = False
    End Sub
End Class