Public Class frm_AutomatischeAnrede
    Private m_Anreden As Anredeliste

    Private Initialisierung As Boolean = False
    Private WithEvents AktAnr As Anrede

    ReadOnly Property Anredeliste() As Anredeliste
        Get
            Return m_Anreden
        End Get
    End Property
    Public Sub New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Fgen Sie Initialisierungen nach dem InitializeComponent()-Aufruf hinzu.
        Me.Icon = My.Resources.bdb2
        Me.LabelErlaeuterung.Text = "In der Briefdatenbank wird aus den eingegebenen Adressdaten automatisch eine Anrede fr den " & _
            "Adressaten ermittelt und im Feld " & Chr(34) & "Briefanrede" & Chr(34) & " gespeichert." & vbCrLf & vbCrLf & _
            "Dazu wird in den Feldern " & Chr(34) & "Firma" & Chr(34) & ", " & Chr(34) & "Firma1" & Chr(34) & _
            ", " & Chr(34) & "Dienststellung" & Chr(34) & ", " & Chr(34) & "Titel" & Chr(34) & " und " & Chr(34) & _
            "Zuname" & Chr(34) & " nach einem Synonym fr einen Titel gesucht." & vbCrLf & vbCrLf & _
            "Die Suchreihenfolge dafr wird hier festgelegt. In den Feldern der Briefdatenbank wird zurerst nach dem ersten Synonym" & _
            " fr den hier obersten Titel gesucht, dann das nchste Synonym usw. Wenn kein Synonym fr diesen Titel gefunden wurde, " & _
            "wird nach Synonymen fr den nchsten Titel gesucht." & vbCrLf & vbCrLf & _
            "Wenn eines der hier aufgefhrten Synonyme gefunden wurde (und damit der passende Titel), wird die Suche beendet." & _
            "Titel und dazugehrende Synonyme sollten nach Wichtigkeit geordnet sein. Weiter oben sollte immer der Titel oder das " & _
            "Synonym stehen, nach dem zuerst gesucht werden soll. " & vbCrLf & vbCrLf & vbCrLf & _
            "Whlen Sie in der Liste " & Chr(34) & "Titel" & Chr(34) & " einen Titel aus und geben Sie hier die bei Ihnen bliche Anrede ein."
        m_Anreden = New Anredeliste
        m_Anreden.Clear()
    End Sub

    Public Sub Initialisieren(ByVal TempAnreden As List(Of Anrede))
        For Each Anr As Anrede In TempAnreden
            m_Anreden.Add(Anr)
        Next
        Me.ObjektListBox1.Initialisieren(m_Anreden)
    End Sub

    Private Sub ObjektListBox1_AktionsAnfrage(ByVal Akt As ObjektListBoxAktion) Handles ObjektListBox1.AktionsAnfrage
        Select Case Akt.Aktion
            Case ObjektListBoxAktionen.ObjektNeu
                Dim Anr As New Anrede
                Anr.Titel = "Neuer Titel"
                m_Anreden.Add(Anr)
                Akt.Obj = Anr
                Akt.Erlaubt = True
            Case ObjektListBoxAktionen.ObjektLschen
                Dim Anr As Anrede = Akt.Obj
                m_Anreden.Remove(Anr)
                Akt.Erlaubt = True
            Case ObjektListBoxAktionen.ObjektNOVerschieben
                Dim Anr As Anrede = Akt.Obj
                Dim Idx As Integer = m_Anreden.IndexOf(Anr)
                m_Anreden.Remove(Anr)
                m_Anreden.Insert(Idx - 1, Anr)
                Akt.Erlaubt = True
            Case ObjektListBoxAktionen.ObjektNUVerschieben
                Dim Anr As Anrede = Akt.Obj
                Dim Idx As Integer = m_Anreden.IndexOf(Anr)
                m_Anreden.Remove(Anr)
                m_Anreden.Insert(Idx + 1, Anr)
                Akt.Erlaubt = True
            Case ObjektListBoxAktionen.ObjektInputBoxAnzeigen
                Dim Anr As Anrede = Akt.Obj
                Dim Frm As New frm_InputBox("Titel ndern:", Anr.Titel, "Briefdatenbank")
                If Frm.ShowDialog = Windows.Forms.DialogResult.OK Then
                    Dim Txt As String = Frm.TextBoxWert.Text.Trim
                    Anr.Titel = Txt
                    Initialisierung = True
                    Me.TBTitel.Text = Txt
                    Initialisierung = False
                    Akt.Erlaubt = True
                End If
        End Select
    End Sub

    Private Sub ObjektListBox1_AuswahlGeaendert(ByVal oAuswahl As Object) Handles ObjektListBox1.AuswahlGeaendert
        AktAnr = oAuswahl
        If IsNothing(AktAnr) Then
            Me.ObjektListBox2.Initialisieren(Nothing)
        Else
            Me.ObjektListBox2.Initialisieren(AktAnr.Synonyme)
        End If
        Initialisierung = True
        If IsNothing(AktAnr) Then
            Me.TBAnredeMnnlich.Text = ""
            Me.TBAnredeWeiblich.Text = ""
            Me.TBMusterAnredeMnnlich.Text = ""
            Me.TBMusterAnredeWeiblich.Text = ""
            Me.TBTitel.Text = ""
            Me.CBmitName.Checked = False
            Me.TBAnredeMnnlich.Enabled = False
            Me.TBAnredeWeiblich.Enabled = False
            Me.TBMusterAnredeMnnlich.Enabled = False
            Me.TBMusterAnredeWeiblich.Enabled = False
            Me.TBTitel.Enabled = False
            Me.CBmitName.Enabled = False

        Else
            Me.TBAnredeMnnlich.Text = AktAnr.AnredeMnnlich
            Me.TBAnredeWeiblich.Text = AktAnr.AnredeWeiblich
            Me.TBMusterAnredeMnnlich.Text = AktAnr.MusterAnredeMnnlich
            Me.TBMusterAnredeWeiblich.Text = AktAnr.MusterAnredeWeiblich
            Me.TBTitel.Text = AktAnr.Titel
            Me.CBmitName.Checked = AktAnr.MitNachname
            Me.TBAnredeMnnlich.Enabled = True
            Me.TBAnredeWeiblich.Enabled = True
            Me.TBMusterAnredeMnnlich.Enabled = True
            Me.TBMusterAnredeWeiblich.Enabled = True
            Me.TBTitel.Enabled = True
            Me.CBmitName.Enabled = True

        End If
        Initialisierung = False
    End Sub

    Private Sub AktAnr_AnredeMnnlichGendert() Handles AktAnr.AnredeMnnlichGendert
        Initialisierung = True
        Me.TBAnredeMnnlich.Text = AktAnr.AnredeMnnlich
        Me.TBMusterAnredeMnnlich.Text = AktAnr.MusterAnredeMnnlich
        Initialisierung = False
    End Sub

    Private Sub AktAnr_AnredeWeiblichGendert() Handles AktAnr.AnredeWeiblichGendert
        Initialisierung = True
        Me.TBAnredeWeiblich.Text = AktAnr.AnredeWeiblich
        Me.TBMusterAnredeWeiblich.Text = AktAnr.MusterAnredeWeiblich
        Initialisierung = False
    End Sub

    Private Sub AktAnr_TitelGendert() Handles AktAnr.TitelGendert
        Initialisierung = True
        Me.TBAnredeMnnlich.Text = AktAnr.AnredeMnnlich
        Me.TBAnredeWeiblich.Text = AktAnr.AnredeWeiblich
        Me.TBMusterAnredeMnnlich.Text = AktAnr.MusterAnredeMnnlich
        Me.TBMusterAnredeWeiblich.Text = AktAnr.MusterAnredeWeiblich
        Initialisierung = False
    End Sub

    Private Sub TBTitel_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TBTitel.TextChanged
        If Initialisierung Then Exit Sub
        If TBTitel.Text.Trim <> "" Then
            AktAnr.Titel = TBTitel.Text.Trim
            Me.ObjektListBox1.TextRefresh()
        End If
    End Sub

    Private Sub TBAnredeMnnlich_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TBAnredeMnnlich.TextChanged
        If Initialisierung Then Exit Sub
        If TBAnredeMnnlich.Text.Trim <> "" Then AktAnr.AnredeMnnlich = TBAnredeMnnlich.Text
    End Sub

    Private Sub TBAnredeWeiblich_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TBAnredeWeiblich.TextChanged
        If Initialisierung Then Exit Sub
        If TBAnredeWeiblich.Text.Trim <> "" Then AktAnr.AnredeWeiblich = TBAnredeWeiblich.Text
    End Sub

    Private Sub CBmitName_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CBmitName.CheckedChanged
        If Initialisierung Then Exit Sub
        AktAnr.MitNachname = CBmitName.Checked
    End Sub

    Private Sub ButtonStandard_Laden_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonStandard_Laden.Click
        m_Anreden.Standard_Anreden_Herstellen()
        Me.ObjektListBox1.Initialisieren(m_Anreden)
    End Sub

    Private Sub ObjektListBox2_AktionsAnfrage(ByVal Akt As ObjektListBoxAktion) Handles ObjektListBox2.AktionsAnfrage
        If IsNothing(AktAnr) Then Exit Sub

        Select Case Akt.Aktion
            Case ObjektListBoxAktionen.ObjektNeu
                Dim Frm As New frm_InputBox("Bitte ein neues Synonym angeben:", "Neues Synonym", "Briefdatenbank")
                If Frm.ShowDialog = Windows.Forms.DialogResult.OK Then
                    Dim Txt As String = Frm.TextBoxWert.Text.Trim
                    AktAnr.Synonyme.Add(Txt)
                    Akt.Obj = Txt
                    Akt.Erlaubt = True
                End If
            Case ObjektListBoxAktionen.ObjektLschen
                AktAnr.Synonyme.RemoveAt(Akt.SelIndex)
                Akt.Erlaubt = True
            Case ObjektListBoxAktionen.ObjektNOVerschieben
                Dim Txt As String = Akt.Obj
                AktAnr.Synonyme.RemoveAt(Akt.SelIndex)
                AktAnr.Synonyme.Insert(Akt.SelIndex - 1, Txt)
                Akt.Erlaubt = True
            Case ObjektListBoxAktionen.ObjektNUVerschieben
                Dim Txt As String = Akt.Obj
                AktAnr.Synonyme.RemoveAt(Akt.SelIndex)
                AktAnr.Synonyme.Insert(Akt.SelIndex + 1, Txt)
                Akt.Erlaubt = True
            Case ObjektListBoxAktionen.ObjektInputBoxAnzeigen
                Dim Txt As String = Akt.Obj
                Dim Frm As New frm_InputBox("Synonym ndern:", Txt, "Briefdatenbank")
                If Frm.ShowDialog = Windows.Forms.DialogResult.OK Then
                    AktAnr.Synonyme(Akt.SelIndex) = Frm.TextBoxWert.Text.Trim
                    Akt.Obj = Frm.TextBoxWert.Text.Trim
                    Akt.Erlaubt = True
                End If
        End Select
    End Sub
End Class