Public Class MainForm
    Private Serv As Briefdatenbank.Service.BriefBearbeitungsService
    Private m_Plugins As List(Of Briefdatenbank.Plugin.Common.PlugInDescription)

    Private m_DateiVerwalter As DateiVerwalter


    Private m_DS As Datensammlung


    Private WithEvents m_Arbeitsadresse As Arbeitsadresse
    Private WithEvents m_Adressliste As Adressliste
    Private WithEvents m_BriefInfoBearbeiter As SelectedBriefInfoliste

    Private WithEvents m_AlleAnzeigenAktion As BeschreibungAktion
    Private WithEvents m_SchliessenAktion As BeschreibungAktion

    Private Initialisierung As Boolean = False


    Private Sub MainForm_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim IL_Briefe As New ImageList()
        IL_Briefe.ImageSize = New Size(14, 14)
        IL_Briefe.Images.Add(My.Resources.Info14)
        IL_Briefe.Images.Add(My.Resources.Brief14)
        IL_Briefe.Images.Add(My.Resources.Rechnung14)
        IL_Briefe.Images.Add(My.Resources.Mahnung14)
        IL_Briefe.Images.Add(My.Resources.Zahlungseingang14)
        IL_Briefe.Images.Add(My.Resources.WichtigeInfo14)
        Me.ListViewBriefe.SmallImageList = IL_Briefe

        PluginMenue_Erstellen()
        m_DateiVerwalter = New DateiVerwalter

        SetDatensammlung(m_DateiVerwalter.CreateDatenSammlung(m_DateiVerwalter.PreviousFiles(0), m_Plugins, Serv))

        m_SchliessenAktion = New BeschreibungAktion("Fertig", "Beendet das Programm.")

        Me.ButtonFertig.Aktion = m_SchliessenAktion
    End Sub


    Private Sub MainForm_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        m_DS.Speichern()
        m_DateiVerwalter.XML_Speichern()
    End Sub

    Private Sub PluginMenue_Erstellen()
        m_Plugins = New List(Of Briefdatenbank.Plugin.Common.PlugInDescription)

        'Plugins kopieren
        If Not IO.Directory.Exists(Application.StartupPath & "\Plugins") Then
            IO.Directory.CreateDirectory(Application.StartupPath & "\Plugins")
        End If
        If Not IO.Directory.Exists(Application.StartupPath & "\PIWork") Then
            IO.Directory.CreateDirectory(Application.StartupPath & "\PIWork")
        End If


        If Serv Is Nothing Then
            Serv = New Briefdatenbank.Service.BriefBearbeitungsService
        End If


        Dim Descriptions() As Briefdatenbank.Plugin.Common.PlugInDescription = Serv.GetProcessorList()
        m_Plugins.AddRange(Descriptions)
        m_Plugins.Sort(New PluginComparer)
    End Sub

    Private Sub SetDatensammlung(ByVal value As Datensammlung)
        If m_DS IsNot value Then
            m_DS = value
            Initialisierung = True
            Neue_Datensammlung_Uebernehmen()
            Initialisierung = False
        End If
    End Sub

    Private Sub Neue_Datensammlung_Uebernehmen()

        Me.DokumentenvorlageComboBox.Items.Clear()
        For Each Vorl As Dokumentenvorlage In m_DS.Vorlagen
            DokumentenvorlageComboBox.Items.Add(Vorl.ToString)
        Next

        Me.TitelComboBox.Items.Clear()
        For Each TI As Titel In m_DS.Titel
            TitelComboBox.Items.Add(TI)
        Next

        Me.Adessauswaehler1.ListViewAdressAuswahl.ContextMenuStrip = m_DS.CreateAdressContextMenuStrip
        Me.ListViewBriefe.ContextMenuStrip = m_DS.CreateBriefContextMenuStrip
        Me.MenuStrip.Items.Remove(Me.EditToolStripMenuItem)
        Me.MenuStrip.Items.Insert(1, m_DS.CreateBearbeitenMenuStrip)

        Me.Adessauswaehler1.Adressliste = m_DS.Adressen
        m_Adressliste = m_DS.Adressen

        Me.ButtonNeueAdresse.Aktion = m_Adressliste.AdresseNeu_Aktion
        Me.ButtonAdresseLoeschen.Aktion = m_Adressliste.AdresseLoeschen_Aktion

        m_AlleAnzeigenAktion = m_Adressliste.AlleAnzeigen_Aktion
        m_Arbeitsadresse = m_Adressliste.Arbeitsadresse

        Arbeitsadresse_lesen()

        m_BriefInfoBearbeiter = m_DS.BriefInfoBearbeiter
        BriefeInfos_ListViewFuellen()

        Me.ButtonNeueInfo.Aktion = m_BriefInfoBearbeiter.InfoNeu_Aktion
        Me.ButtonNeuerBrief.Aktion = m_BriefInfoBearbeiter.BriefNeu_Aktion
        Me.ButtonBriefLoeschen.Aktion = m_BriefInfoBearbeiter.BILoesch_Aktion
        Me.ButtonBriefBearbeiten.Aktion = m_BriefInfoBearbeiter.BIBearbeit_Aktion
    End Sub

#Region " Arbeitsadresse lesen "
    Private Sub Arbeitsadresse_lesen()
        Initialisierung = True
        Me.FirmaTextBox.Text = m_Arbeitsadresse.Firma
        Me.Firma1TextBox.Text = m_Arbeitsadresse.Firma1
        Me.StellungTextBox.Text = m_Arbeitsadresse.Stellung
        Me.FirmavoranCheckBox.Checked = m_Arbeitsadresse.Firmavoran
        Select Case m_Arbeitsadresse.Geschlecht
            Case Geschlechter.mnnlich
                Me.RadioButtonMaennl.Checked = True
            Case Geschlechter.weiblich
                Me.RadioButtonWeibl.Checked = True
            Case Geschlechter.unpersnlich
                Me.RadioButtonUnpers.Checked = True
        End Select
        Me.TitelComboBox.Text = m_Arbeitsadresse.Titel
        Me.NachnameTextBox.Text = m_Arbeitsadresse.Nachname
        Me.VornameTextBox.Text = m_Arbeitsadresse.Vorname
        Me.OrtTextBox.Text = m_Arbeitsadresse.Ort
        Me.PlzTextBox.Text = m_Arbeitsadresse.PLZ
        Me.StrasseTextBox.Text = m_Arbeitsadresse.Strasse
        Me.BriefanredeComboBox.Text = m_Arbeitsadresse.Briefanrede
        Me.GeburtstagTextBox.Text = m_Arbeitsadresse.Geburtstag
        Me.WWWTextBox.Text = m_Arbeitsadresse.www
        Me.TelefonTextBox.Text = m_Arbeitsadresse.Telefon
        Me.FaxTextBox.Text = m_Arbeitsadresse.Fax
        Me.EmailTextBox.Text = m_Arbeitsadresse.Email
        Me.MobilTextBox.Text = m_Arbeitsadresse.Mobil
        Me.BetreffTextBox.Text = m_Arbeitsadresse.Betreff
        Me.BemerkungTextBox.Text = m_Arbeitsadresse.Bemerkung

        BriefanredeCombo_Fllen()

        If Not Me.DokumentenvorlageComboBox.Items.Contains(m_Arbeitsadresse.Dokumentenvorlage) Then
            m_Arbeitsadresse.Dokumentenvorlage = "Standardbrief"
        End If
        Me.DokumentenvorlageComboBox.Text = m_Arbeitsadresse.Dokumentenvorlage



        Me.AnschriftTextBox.Text = m_Arbeitsadresse.AnschriftOben.Trim & vbCrLf & vbCrLf & m_Arbeitsadresse.Briefanrede

        Initialisierung = False
    End Sub
    Private Sub BriefanredeCombo_Fllen()
        Me.BriefanredeComboBox.BeginUpdate()
        Me.BriefanredeComboBox.Items.Clear()
        Me.BriefanredeComboBox.Items.AddRange(m_Arbeitsadresse.Liste_AnredeVorschlaege.ToArray)
        Me.BriefanredeComboBox.EndUpdate()
        Me.BriefanredeComboBox.Text = m_Arbeitsadresse.Briefanrede
    End Sub
    Private Sub BriefeInfos_ListViewFuellen()
        Me.ListViewBriefe.Items.Clear()

        'm_Arbeitsadresse.Adresse.Briefe.Sort(New BriefInfoComparer)
        For Each LBI As BriefInfo In m_BriefInfoBearbeiter
            Me.ListViewBriefe.Items.Add(New BriefListViewItem(LBI))
        Next

        For Each LBI As BriefListViewItem In Me.ListViewBriefe.Items
            If m_BriefInfoBearbeiter.SelectedElement Is LBI.BriefInfo Then
                LBI.Selected = True
                Exit For
            End If
        Next
        Me.SchuldenTextBox.Text = m_BriefInfoBearbeiter.Schulden.ToString("c")
    End Sub
#End Region

#Region " Arbeitsadresse schreiben "
    Private Sub FirmaTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FirmaTextBox.TextChanged
        If Initialisierung Then Exit Sub
        m_Arbeitsadresse.Firma = FirmaTextBox.Text
    End Sub

    Private Sub Firma1TextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Firma1TextBox.TextChanged
        If Initialisierung Then Exit Sub
        m_Arbeitsadresse.Firma1 = Firma1TextBox.Text
    End Sub

    Private Sub StellungTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StellungTextBox.TextChanged
        If Initialisierung Then Exit Sub
        m_Arbeitsadresse.Stellung = StellungTextBox.Text
    End Sub

    Private Sub FirmavoranCheckBox_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FirmavoranCheckBox.CheckedChanged
        If Initialisierung Then Exit Sub
        m_Arbeitsadresse.Firmavoran = FirmavoranCheckBox.Checked
    End Sub

    Private Sub GeschlechtChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButtonMaennl.CheckedChanged, RadioButtonWeibl.CheckedChanged, RadioButtonUnpers.CheckedChanged
        If Initialisierung Then Exit Sub
        If Me.RadioButtonMaennl.Checked Then
            m_Arbeitsadresse.Geschlecht = Geschlechter.mnnlich
        ElseIf Me.RadioButtonWeibl.Checked Then
            m_Arbeitsadresse.Geschlecht = Geschlechter.weiblich
        ElseIf Me.RadioButtonUnpers.Checked Then
            m_Arbeitsadresse.Geschlecht = Geschlechter.unpersnlich
        End If
    End Sub
    Private Sub TitelComboBox_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TitelComboBox.TextChanged
        If Initialisierung Then Exit Sub
        m_Arbeitsadresse.Titel = TitelComboBox.Text
    End Sub

    Private Sub NachnameTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NachnameTextBox.TextChanged
        If Initialisierung Then Exit Sub
        m_Arbeitsadresse.Nachname = NachnameTextBox.Text
    End Sub

    Private Sub VornameTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles VornameTextBox.TextChanged
        If Initialisierung Then Exit Sub
        m_Arbeitsadresse.Vorname = VornameTextBox.Text
    End Sub

    Private Sub StrasseTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles StrasseTextBox.TextChanged
        If Initialisierung Then Exit Sub
        m_Arbeitsadresse.Strasse = StrasseTextBox.Text
    End Sub

    Private Sub PlzTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PlzTextBox.TextChanged
        If Initialisierung Then Exit Sub
        m_Arbeitsadresse.PLZ = PlzTextBox.Text
    End Sub

    Private Sub OrtTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OrtTextBox.TextChanged
        If Initialisierung Then Exit Sub
        m_Arbeitsadresse.Ort = OrtTextBox.Text
    End Sub


    Private Sub BriefanredeComboBox_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles BriefanredeComboBox.TextChanged
        If Initialisierung Then Exit Sub
        m_Arbeitsadresse.ManuellAnredeAenderung = True
        m_Arbeitsadresse.Briefanrede = BriefanredeComboBox.Text
        m_Arbeitsadresse.ManuellAnredeAenderung = False
    End Sub

    Private Sub GeburtstagTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GeburtstagTextBox.TextChanged
        If Initialisierung Then Exit Sub
        m_Arbeitsadresse.Geburtstag = GeburtstagTextBox.Text
    End Sub

    Private Sub TelefonTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TelefonTextBox.TextChanged
        If Initialisierung Then Exit Sub
        m_Arbeitsadresse.Telefon = TelefonTextBox.Text
    End Sub

    Private Sub MobilTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MobilTextBox.TextChanged
        If Initialisierung Then Exit Sub
        m_Arbeitsadresse.Mobil = MobilTextBox.Text
    End Sub

    Private Sub FaxTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FaxTextBox.TextChanged
        If Initialisierung Then Exit Sub
        m_Arbeitsadresse.Fax = FaxTextBox.Text
    End Sub

    Private Sub EmailTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EmailTextBox.TextChanged
        If Initialisierung Then Exit Sub
        m_Arbeitsadresse.Email = EmailTextBox.Text
    End Sub

    Private Sub WWWTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WWWTextBox.TextChanged
        If Initialisierung Then Exit Sub
        m_Arbeitsadresse.www = WWWTextBox.Text
    End Sub

    Private Sub BetreffTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BetreffTextBox.TextChanged
        If Initialisierung Then Exit Sub
        m_Arbeitsadresse.Betreff = BetreffTextBox.Text
    End Sub

    Private Sub BemerkungTextBox_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BemerkungTextBox.TextChanged
        If Initialisierung Then Exit Sub
        m_Arbeitsadresse.Bemerkung = BemerkungTextBox.Text
    End Sub

    Private Sub DokumentenvorlageComboBox_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DokumentenvorlageComboBox.SelectedIndexChanged
        If Initialisierung Then Exit Sub
        m_Arbeitsadresse.Dokumentenvorlage = DokumentenvorlageComboBox.Text
    End Sub

#End Region



    Private Sub m_Adressliste_ElementSelectedChanged(ByVal NewSelectedElement As Adresse, ByVal Sender As Object) Handles m_Adressliste.ElementSelectedChanged
        m_Arbeitsadresse = m_Adressliste.Arbeitsadresse
        Arbeitsadresse_lesen()
    End Sub

    Private Sub m_BriefInfoBearbeiter_ElementAdded(ByVal AddedElement As BriefInfo) Handles m_BriefInfoBearbeiter.ElementAdded
        Dim LBI As New BriefListViewItem(AddedElement)
        Me.ListViewBriefe.Items.Insert(0, LBI)
    End Sub

    Private Sub m_BriefInfoBearbeiter_ElementRemoved(ByVal RemovedElement As BriefInfo) Handles m_BriefInfoBearbeiter.ElementRemoved
        For Each LBI As BriefListViewItem In Me.ListViewBriefe.Items
            If LBI.BriefInfo Is RemovedElement Then
                Me.ListViewBriefe.Items.Remove(LBI)
                Exit For
            End If
        Next
    End Sub

    Private Sub m_BriefInfoBearbeiter_ElementSelectedChanged(ByVal NewSelectedElement As BriefInfo, ByVal Sender As Object) Handles m_BriefInfoBearbeiter.ElementSelectedChanged
        If Sender Is Me Then Exit Sub
        For Each LBI As BriefListViewItem In Me.ListViewBriefe.Items
            If m_BriefInfoBearbeiter.SelectedElement Is LBI.BriefInfo Then
                LBI.Selected = True
                Exit For
            End If
        Next
    End Sub

    Private Sub m_BriefInfoBearbeiter_Liste_Komplett_Geaendert() Handles m_BriefInfoBearbeiter.Liste_Komplett_Geaendert
        BriefeInfos_ListViewFuellen()
    End Sub

    Private Sub m_BriefInfoBearbeiter_Schulden_Geaendert() Handles m_BriefInfoBearbeiter.Schulden_Geaendert
        Me.SchuldenTextBox.Text = m_BriefInfoBearbeiter.Schulden.ToString("c")
    End Sub

    Private Sub ListViewBriefe_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListViewBriefe.SelectedIndexChanged
        If ListViewBriefe.SelectedItems.Count > 0 Then
            Dim BLI As BriefListViewItem = ListViewBriefe.SelectedItems(0)
            m_BriefInfoBearbeiter.SetSelectedElement(BLI.BriefInfo, Me)
        Else
            m_BriefInfoBearbeiter.SetSelectedElement(Nothing, Me)
        End If
    End Sub

    Private Sub Adessauswaehler1_SuchEinschraenkungVorhanden(ByVal Sucheeingeschraenkt As Boolean) Handles Adessauswaehler1.SuchEinschraenkungVorhanden
        m_Adressliste.AlleAnzeigenGruppe.Visible = Sucheeingeschraenkt
    End Sub

    Private Sub m_AlleAnzeigenAktion_Aktion() Handles m_AlleAnzeigenAktion.Aktion
        Me.Adessauswaehler1.AdresseinschraenkungTextBox.Text = ""
    End Sub

    Private Sub TitelVorschlgeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TitelVorschlgeToolStripMenuItem.Click
        Dim TempListe As New List(Of Titel)
        For Each Ti As Titel In m_DS.Titel
            Dim NeuTitel As New Titel(Ti.Text)
            TempListe.Add(NeuTitel)
        Next
        Dim frm As New frm_Titelvorschlaege_Bearbeiten
        frm.Initialisieren(TempListe)
        If frm.ShowDialog = Windows.Forms.DialogResult.OK Then
            If frm.Titelliste.Count > 0 Then
                m_DS.Titel.Clear()
                Me.TitelComboBox.Items.Clear()
                For Each TI As Titel In frm.Titelliste
                    m_DS.Titel.Add(TI)
                    TitelComboBox.Items.Add(TI)
                Next
            End If
        End If
    End Sub

    Private Sub AutomatischeAnredeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AutomatischeAnredeToolStripMenuItem.Click
        Dim TempListe As New List(Of Anrede)
        For Each Anr As Anrede In m_DS.Anreden
            Dim NeuAnr As Anrede = Anr.Clone
            TempListe.Add(NeuAnr)
        Next
        Dim frm As New frm_AutomatischeAnrede
        frm.Initialisieren(TempListe)
        If frm.ShowDialog = Windows.Forms.DialogResult.OK Then
            If frm.Anredeliste.Count > 0 Then
                m_DS.Anreden = frm.Anredeliste
                BriefanredeCombo_Fllen()
            End If
        End If

    End Sub

    Private Sub m_Arbeitsadresse_Aenderung_Anrede() Handles m_Arbeitsadresse.Aenderung_Anrede
        Initialisierung = True
        Me.BriefanredeComboBox.Text = m_Arbeitsadresse.Briefanrede
        Me.AnschriftTextBox.Text = m_Arbeitsadresse.AnschriftOben.Trim & vbCrLf & vbCrLf & m_Arbeitsadresse.Briefanrede
        Initialisierung = False
    End Sub

    Private Sub m_Arbeitsadresse_Aenderung_Anrede_manuell() Handles m_Arbeitsadresse.Aenderung_Anrede_manuell
        Me.AnschriftTextBox.Text = m_Arbeitsadresse.AnschriftOben.Trim & vbCrLf & vbCrLf & m_Arbeitsadresse.Briefanrede
    End Sub

    Private Sub m_Arbeitsadresse_Aenderung_AnredeVorschlaege() Handles m_Arbeitsadresse.Aenderung_AnredeVorschlaege
        Initialisierung = True
        Me.BriefanredeComboBox.Items.Clear()
        Me.BriefanredeComboBox.Items.AddRange(m_Arbeitsadresse.Liste_AnredeVorschlaege.ToArray)
        Initialisierung = False
    End Sub

    Private Sub m_Arbeitsadresse_Aenderung_Anschrift() Handles m_Arbeitsadresse.Aenderung_Anschrift
        Me.AnschriftTextBox.Text = m_Arbeitsadresse.AnschriftOben.Trim & vbCrLf & vbCrLf & m_Arbeitsadresse.Briefanrede
    End Sub

    Private Sub NeueDokumentenvorlageToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NeueDokumentenvorlageToolStripMenuItem.Click
        Dim frm As New frm_InputBox("Bitte Namen fr die neue Dokumentenvorlage angeben:", "", "Briefdatenbank")
        If frm.ShowDialog = Windows.Forms.DialogResult.OK Then
            Dim DokumentName As String = frm.TextBoxWert.Text.Trim
            Dim WF As New WordFunktionen
            DokumentName = WF.DateinameSonderzeichenErsetzen(DokumentName)
            If DokumentName <> "" Then

                If WF.Dok_VorlageErstellen(DokumentName, m_DS.VorlagenDirectory) Then
                    Me.DokumentenvorlageComboBox.Items.Add(DokumentName)
                    Me.DokumentenvorlageComboBox.Text = DokumentName

                End If
            End If
        End If
    End Sub

    Private Sub NeueStandardvorlageToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NeueStandardvorlageToolStripMenuItem.Click
        Try
            Dim TempVorlagenPfad As String = m_DS.VorlagenDirectory & "\~TempStandardVorlage.dot"
            Dim VorlagenPfad As String = m_DS.VorlagenDirectory & "\Standardbrief.dot"

            If IO.File.Exists(TempVorlagenPfad) Then
                IO.File.Delete(TempVorlagenPfad)
            End If
            Dim WF As New WordFunktionen

            If WF.Dok_VorlageErstellen("~TempStandardVorlage", m_DS.VorlagenDirectory) Then
                IO.File.Copy(TempVorlagenPfad, VorlagenPfad, True)
                Me.DokumentenvorlageComboBox.Text = "Standardbrief"
                IO.File.Delete(TempVorlagenPfad)
            End If

        Catch ex As Exception

        End Try

    End Sub

    Private Sub SchuldnerSuchenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SchuldnerSuchenToolStripMenuItem.Click
        Me.Adessauswaehler1.Schuldner_Suchen()
    End Sub

    Private Sub WichtigeInfosSuchenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles WichtigeInfosSuchenToolStripMenuItem.Click
        Me.Adessauswaehler1.Wichtige_Infos_Suchen()
    End Sub

    Private Sub RechnungSuchenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RechnungSuchenToolStripMenuItem.Click
        Me.Adessauswaehler1.RechnungsNummer_Suchen()
    End Sub

    Private Sub OpenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenToolStripMenuItem.Click
        Dim Dlg As New OpenFileDialog
        Dlg.Filter = "Briefdatenbank Dateien (*.bdbxml)|*.bdbxml"
        Dlg.FilterIndex = 1
        Dlg.RestoreDirectory = True

        If Dlg.ShowDialog() = Windows.Forms.DialogResult.OK Then
            SetDatensammlung(m_DateiVerwalter.CreateDatenSammlung(Dlg.FileName, m_Plugins, Serv))

        End If

    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        Me.Close()
    End Sub

#Region " Resize "
    Private Sub ListViewBriefe_SizeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ListViewBriefe.SizeChanged
        Me.ListViewBriefe.Columns(0).Width = 95
        Me.ListViewBriefe.Columns(1).Width = 60
        Me.ListViewBriefe.Columns(2).Width = ListViewBriefe.Width - 162
    End Sub

    Private Sub PanelButtonsRechts_SizeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles PanelButtonsRechts.SizeChanged
        If Me.PanelButtonsRechts.Width < 258 Then
            Me.ButtonFertig.Visible = False
        Else
            Me.ButtonFertig.Visible = True
        End If
    End Sub
    Private Sub BriefanredeComboBox_SizeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles BriefanredeComboBox.SizeChanged
        If BriefanredeComboBox.SelectedIndex > -1 Then
            BriefanredeComboBox.SelectionLength = 0
        End If
    End Sub
    Private Sub DokumentenvorlageComboBox_SizeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles DokumentenvorlageComboBox.SizeChanged
        If DokumentenvorlageComboBox.SelectedIndex > -1 Then
            DokumentenvorlageComboBox.SelectionLength = 0
        End If
    End Sub
    Private Sub TitelComboBox_SizeChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TitelComboBox.SizeChanged
        If TitelComboBox.SelectedIndex > -1 Then
            TitelComboBox.SelectionLength = 0
        End If
    End Sub
#End Region

    Private Sub m_SchliessenAktion_Aktion() Handles m_SchliessenAktion.Aktion
        Me.Close()
    End Sub

    Private Sub Buttonwww_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Buttonwww.Click
        If Me.WWWTextBox.Text.Trim = "" Then Exit Sub
        Try
            Dim psi As New ProcessStartInfo
            psi.UseShellExecute = True
            psi.FileName = WWWTextBox.Text.Trim
            Process.Start(psi)
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Briefdatenbank", MessageBoxButtons.OK, MessageBoxIcon.Error)
        End Try
    End Sub

    Private Sub VorhandeneWordDokumenteToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles VorhandeneWordDokumenteToolStripMenuItem.Click

    End Sub

    Private Sub SchulnerToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SchulnerToolStripMenuItem.Click
        'Schuldner nach Excel
        Dim ExcelApp As Excel.Application = New Excel.Application
        Dim XLBook As Excel.Workbook = ExcelApp.Workbooks.Add
        Dim XLSheet As Excel.Worksheet = XLBook.Worksheets(1)

        ExcelApp.Visible = True
        XLSheet.Visible = True

        Dim Schulden As Decimal
        Dim Zaehler As Integer = 0
        Dim LetztesBriefdatum As Date

        For Each Adr As Adresse In m_DS.Adressen
            Schulden = 0D
            For Each BI As BriefInfo In Adr.Briefe
                If (BI.Contents And BriefInfoContents.Geld) <> 0 Then
                    Dim GE As IGeldelement = BI
                    Schulden += GE.Geldbetrag
                    LetztesBriefdatum = BI.Datum
                End If
            Next
            If Schulden < 0D Then
                Zaehler += 1
                XLSheet.Cells(Zaehler, 1) = LetztesBriefdatum.ToShortDateString
                XLSheet.Cells(Zaehler, 2) = Adr.Kuerzel_Erstellen
                XLSheet.Cells(Zaehler, 3) = Format(Schulden, "c")
            End If
        Next
    End Sub


End Class